/*********************************************************/
/* This source code copyright (c) 1991-2001, Aaron Giles */
/* See the Read Me file for licensing information.       */
/* Contact email: mac@aarongiles.com                     */
/*********************************************************/

/*
 * JPEGView resource header file, to be #included with every JPEGView code 
 *		segment and with the resource definition file
 */

/* General defines */
#define kVersion 0x0330
#define kPrefsVersion 0x0332
#define kCreator 'JVWR'
#define kDarksideCreator 'DSOM'

#define kPrefsPrintType 'Prnt'
#define kPrefsAliasType 'Alis'
#define kPrefsSlideType 'Slid'

#define kPatchType 'xPAT'
#define rQDxDispatchPatch 128

#define rCustomIcon -16455

#define windoidProc 2048
#define windoidZoomProc 2048 + 8

#define customMenuProc 1
#define option condense
#define shift extend

/* AppleEvent suites */
#define kJPEGViewSuite kCreator

/* AppleEvent classes */
#define cImage 'imag'

/* AppleEvent events */
#define kAESlideShow 'Jssh'
#define kAEQuantizeImage 'Jqim'

/* AppleEvent properties: cImages */
#define pComments 'Jcom'
#define pCompression 'Jcmp'
#define pDisplayTime 'Jdti'
#define pHasImageColorTable 'Jhct'
#define pHasQuantColorTable 'Jhqt'
#define pImageColorTable 'Jimc'
#define pImageFormat 'Jimf'
#define pIsAborted 'Jabt'
#define pIsBanded 'Jban'
#define pIsCompressed 'Jicp'
#define pIsCorrupt 'Jcor'
#define pIsCropped 'Jcrp'
#define pLength 'Jlgh'
#define pOriginalBounds 'Jobd'
#define pQuantColorTable 'Jquc'
#define pQuantTime 'Jqti'

/* AppleEvent properties: cDrawingAreas */
#define pDrawQuality 'Jdrq'
#define pPalette 'Jpal'

/* AppleEvent properties: cWindows */
#define pFullScreen 'Jful'
#define pWindowType 'Jwty'

/* AppleEvent parameter keys: Quantize Image */
#define keyColorCount 'Jcct'

/* AppleEvent parameter keys: Close */
#define keyRestoreColors 'Jrcl'

/* AppleEvent parameter keys: Open Documents */
#define keyAutoComments 'Jacm'
#define keyAutoExpand 'Jaex'
#define keyChangeCreator 'Jccr'
#define keyFixTypes 'Jfix'
#define keyNoErrors 'Jner'
#define keyOpenScreen 'Josc'
#define keyOpenFull 'Jofl'
#define keyOpenPalette 'Jopl'
#define keyOpenQuality 'Joql'
#define keyOpenBitmaps 'Jobm'
#define keyVisible 'Jvis'

/* AppleEvent parameter keys: Save */
#define keyCreatePreview 'Jcpv'
#define keyCropWhat 'Jccw'
#define keyMakeIcons 'Jmic'
#define keySaveQuant 'Jsqu'

/* AppleEvent parameter keys: Slide Show */
#define keyDelay 'Jdel'
#define keyFilenames 'Jfnm'
#define keyFromDisk 'Jdsk'
#define keyHideControls 'Jhcl'
#define keyHideWindoids 'Jhwo'
#define keyIgnoreErrors 'Jige'
#define keyImportFiles 'Jimp'
#define keyOffscreen 'Joff'
#define keyRandom 'Jrnd'
#define keyRepeat 'Jrpt'
#define keyScanRecursive 'Jrcv'
#define keyScreenSaver 'Jssv'
#define keyUserControl 'Jucl'

/* AppleEvent enumeration extensions */
#define kAEQDDitherCopy 'Jdth'

#define enumDrawQuality 'Jdrq'
#define kAEDQVeryHigh 'Jvhi'
#define kAEDQHigh 'Jhi '
#define kAEDQNormal 'Jnor'

#define enumOpenScreen 'Josc'
#define kAEOSDeepestColor 'Jdcl'
#define kAEOSDeepestGray 'Jdgy'
#define kAEOSLargestColor 'Jlcl'
#define kAEOSLargestGray 'Jlgy'
#define kAEOSMain 'Jmai'

#define enumOpenFull 'Jofl'
#define kAEOFAlways 'Jalw'
#define kAEOFAlwaysIfLarge 'Jall'
#define kAEOFAskIfLarge 'Jakl'
#define kAEOFNever 'Jnvr'

#define enumOpenPalette 'Jopl'
#define kAEOPQuantImageScrn 'Jqis'
#define kAEOPImageQuantScrn 'Jiqs'
#define kAEOPQuantScrn 'Jqs '
#define kAEOPImageScrn 'Jis '
#define kAEOPScrn 'Jsoy'

#define enumPalette 'Jpal'
#define kAEPSystem 'Jsys'
#define kAEPGrayscale 'Jgry'
#define kAEPImage 'Jimg'
#define kAEPQuantized 'Jquz'

#define enumWindowType 'Jwty'
#define kAEWTStatistics 'Jstw'
#define kAEWTComments 'Jcmw'
#define kAEWTColors 'Jclw'
#define kAEWTHelp 'Jhlw'
#define kAEWTPreferences 'Jprd'
#define kAEWTSlideShow 'Jssd'
#define kAEWTImage 'Jimw'
#define kAEWTFullImage 'Jfiw'
#define kAEWTAbout 'Jabt'
#define kAEWTSlideControls 'Jscw'
#define kAEWTAboutHelp 'Jahw'

/* Window and Dialog IDs */
#define kSlideShowDialogID kAEWTSlideShow
#define kSlideControlsWindowID kAEWTSlideControls
#define kPrefsDialogID kAEWTPreferences
#define kStatWindowID kAEWTStatistics
#define kCommentsWindowID kAEWTComments
#define kColorsWindowID kAEWTColors
#define kHelpWindowID kAEWTHelp
#define kImageWindowID kAEWTImage
#define kFImageWindowID kAEWTFullImage
#define kAboutWindowID kAEWTAbout
#define kAboutHelpDialogID kAEWTAboutHelp

#define kAboutDialogID 'Jabd'
#define kProgressDialogID 'Jpgd'
#define kOpenDialogID 'Jopd'
#define kSaveDialogID 'Jsvd'
#define kFolderDialogID 'Jfld'

#define kNoCompression 0
#define kCCITTCompression 'CIT3'
#define kPackBitsCompression 'PACK'
#define kLZWCompression 'LZW '
#define kJPEGCompression 'jpeg'
#define kVideoCompression 'rpza'
#define kAnimationCompression 'rle '
#define kRawCompression 'raw '
#define kGraphicsCompression 'smc '
#define kCinepackCompression 'cdvc'
#define kRLE4Compression 'RLE4'
#define kRLE8Compression 'RLE8'

/* File types */
#define kPrefsType 'pref'
#define kAPPLType 'APPL'
#define kPICTType 'PICT'
#define kJFIFType 'JFIF'
#define kJPEGType 'JPEG'
#define kHelpType 'HLP!'
#define kGIFType 'GIFf'
#define kTIFFType 'TIFF'
#define kAllTypes '****'
#define kSCRNType 'SCRN'
#define kBMPType 'BMPp'
#define kPNTGType 'PNTG'

/* FREF/BNDL/JVWR resources */
#define rAPPLType 128
#define rPICTType 129
#define rJFIFType 130
#define rJPEGType 131
#define rHelpType 132
#define rGIFType 133
#define rAllTypes 134
#define rTIFFType 135
#define rBMPType 136
#define rSCRNType 137
#define rPNTGType 138

#define rAPPLID 0
#define rPICTID 1
#define rJFIFID 2
#define rJPEGID 3
#define rHelpID 4
#define rGIFID 5
#define rAllID 6
#define rTIFFID 7
#define rBMPID 8
#define rSCRNID 9
#define rPNTGID 10

#define rBNDLRsrc 128

#define rJVWRRsrc 0

#define rStandardButton 1000
#define rDepressedButton 2000
#define rDisabledButton 3000
#define rForwardButton 0
#define rStopButton 1
#define rPauseButton 2
#define rReverseButton 3
#define rDoubleForwardButton 4
#define rDoubleReverseButton 5

/* WIND/wctb resources */
#define rStatWindow 128
#define rCommentsWindow 129
#define rColorsWindow 130
#define rSlideControlsWindow 131
#define rImageWindow 132
#define rFullImageWindow 133
#define rHelpWindow 134
#define rAboutImageWindow 135
#define rAboutBox 384

/* STR# resources */
#define rFatalErrors 128
#define rMinorErrors 129
#define rStringErrors 130
#define rGenericStringErrors 131
#define rStrings 132
#define rFormatNames 133

/* MBAR resources */
#define rMenuBar 128

/* MENU resources */
#define rIconMenu 119
#define rCropMenu 120
#define rSaveMenu 121
#define rSlideControlMenu 122
#define rSlideSourceMenu 123
#define rTimeMenu 124
#define rQualityMenuID "\0x7d"
#define rQualityMenu 125
#define rPrefsMenu 126
#define rHelpMenu 127

#define rAppleMenu 128
#define rFileMenu 129
#define rEditMenu 130
#define rViewMenu 131
#define rColorsMenu 132
#define rWindowMenu 133

/* DITL resources */
#define rOpenDialog 129
#define rSaveDialog 130
#define rFolderDialog 131
#define rSlideShowDialog 133
#define rPrefsDialog 134
#define rProgressDialog 135
#define rAboutHelpDialog 136
#define rModalProgressDialog 137
#define rOpenDialogNoQT 138
#define rSimpleSaveDialog 139

#define rMinorAlert 256
#define rFatalAlert 257
#define rUnknownAlert 258
#define rAbortSlidesAlert 260
#define rEndSlidesAlert 261
#define rSlideMemAlert 262
#define rTooBigAlert 263
#define rBadJPEGAlert 264
#define rNeeds68020Alert 265
#define rNeedsSystem7Alert 266
#define rPowerPCAlert 9876

/* CTRL resources */
#define rPrefsMenuControl 128
#define rHelpMenuControl 129
#define rHelpScrollControl 130
#define rTimeMenuControl 131
#define rSlideControlMenuControl 132
#define rSlideSourceMenuControl 133
#define rSavePopupControl 134
#define rCropPopupControl 135
#define rIconPopupControl 136

/* CURS resources */
#define rHandCursor 128
#define rFirstSpin 129
#define rLastSpin 156
#define rSizeCursor 157

/* ICON resources */
#define rAPPLIcon 128
#define rPICTIcon 129
#define rOtherIcon 130
#define rJPEGIcon 131
#define rHelpIcon 132
#define rGIFIcon 133
#define rTIFFIcon 134
#define rBMPIcon 135
#define rSCRNIcon 136
#define rPNTGIcon 137

/* PICT resources */
#define rAboutPict 128
#define rAboutHelpPict 129

/* TEXT/styl resoources */
#define kHelpTextBase 128
#define rCreditsText 300

/*** Error constants ***/
#define errNoMemory 1
#define errNoLoadCode 2
#define errNoLoadStrings 3
#define errNoLoadCursor 4
#define errNoSystem7 5
#define errNoLoadCLUT 6
#define errNoMenu 7
#define errNoAppleEvents 8
#define errNoDeviceInfo 9

#define errFunnyQTVersion 2
#define errNoAboutDialog 3
#define errNoAESend 4
#define errNoHelp 5
#define errNoPrefsDialog 6
#define errCantWritePrefs 7
#define errNoImagesFound 8
#define errNoSlideDialog 9
#define errCantAddPreview 10
#define errNoPrinterSelected 11
#define errNoHelpFound 12

#define errCorruptImage 1
#define errInvalidFile 2
#define errCantOpenFile 3
#define errNoDrawMemory 4
#define errNoLoadMemory 5
#define errCantReadFile 6
#define errCantWriteFile 7
#define errCantCreateFile 8
#define errNoUnwrapMemory 9
#define errNoWrapMemory 10
#define errCantOpenWindow 11
#define errNoOffscreenMemory 12
#define errNoQuantMemory 13
#define errCantMakePreview 14
#define errNoColorsMemory 15
#define errCantCreateIcons 16
#define errNoCropMemory 17
#define errNoSaveMemory 18
#define errHSIFile 19
#define errNoPrintMemory 20
#define errCantPrint 21
#define errNoCopyMemory 22
#define errBadTIFFExtension 23
#define errNoQuickTime 24
#define errJPEGError 25
#define errBinHexData 26
#define errUUEncodeData 27

/*** String constants ***/
#define strFileName 0
#define strImageSize 1
#define strImageColors 2
#define strImageStatus 3
#define strCompression 4
#define strFileFormat 5
#define strImageLength 6

#define strDisplayedSize 7
#define strDisplayedColors 8
#define strDisplayQuality 9
#define strDisplayTime 10
#define strOffscreenBitmap 11

#define strFreeMemory 12

#define strImageSize1 13
#define strImageSize2 14
#define strImageColors1 15
#define strImageColors2 16
#define strNormal 17
#define strAborted 18
#define strBanded 19
#define strCropped 20
#define strCorrupt 21
#define strLZWGIF 22
#define strAdobeJPEG 23
#define strQuickTimeJPEG 24
#define strQuality 25
#define strIJGJPEG 26
#define strUnknownJPEG 27
#define strUncompressed 28
#define strPICT 29
#define strJPEG 30
#define strGIF 31
#define strImageLength1 32
#define strImageLength2 33
#define strImageLength3 34

#define strDisplayedSize1 35
#define strDisplayedSize2 36
#define strDisplayedSize3 37
#define strDisplayedColors1 38
#define strDisplayedColors2 39
#define strSystemColors1 40
#define strGrayscales1 41
#define strImageColorsX1 42
#define strReducedColors1 43
#define strSystemColors2 44
#define strGrayscales2 45
#define strImageColorsX2 46
#define strReducedColors2 47
#define strVeryHigh 48
#define strHigh 49
#define strNormalQ 50
#define strNA 51
#define strDisplayTime1 52
#define strNoBitmap 53
#define strOffscreenBitmap1 54
#define strOffscreenBitmap2 55
#define strFreeMemory1 56

#define strSummary1 57

#define strThousands 58
#define strMillions 59
#define strJPEGView 60
#define strJPEGViewHelp 61
#define strJPEGViewPICT 62
#define strJPEGViewPrefs 63
#define strJPEGViewTempFile 64
#define strSelect 65
#define strDesktop 66
#define strDecompressing 67
#define strDithering 68
#define strScaling 69
#define strReducingTo 70
#define strCreatingPreview 71
#define strCreatingIcons 72
#define strCreatingPreviewIcons 73
#define strSaving 74

#define strNagMessages 75
// thru 86

#define strNoComments 87
#define strRestart 88
#define strResume 89
#define strShowStatistics 90
#define strHideStatistics 91
#define strShowComments 92
#define strHideComments 93
#define strShowColors 94
#define strHideColors 95
#define strBeginSlideShow 96
#define strResumeSlideShow 97
#define strSSNone 98
#define strAboutJPEGView 99
#define strVersionPPC 100
#define strVersion68k 101
#define strSlideLoading 102
#define strSlideReducing 103
#define strSlideDrawing 104
#define strSlideReady 105
#define strSlidePaused 106
#define strSlideDelaying 107
#define strSlideRendering 108
#define strScanningDirectory 109
#define strPrinting 110
#define strCopying 111
#define strPreparing 112
#define strCCITT3 113
#define strPackBits 114
#define strLZW 115
#define strRLE4 116
#define strRLE8 117
#define strLZWPredict 118
#define strHelpFile 119
#define strLast 120

/*** Slide control menu constants ***/
#define slideControlUserItem 1
#define slideControlAutoItem 2

/*** Slide source menu constants ***/
#define slideSourceMemoryItem 1
#define slideSourceDiskItem 2

/*** Time menu constants ***/
#define timeSeconds 1
#define timeMinutes 2
#define timeHours 3

/*** Quality menu constants ***/
#define qualityVHighItem 1
#define qualityHighItem 2
#define qualityMediumItem 3

/*** Prefs menu constants ***/
#define prefsWindows 1
#define prefsDisplay 2
#define prefsOffscreen 3
#define prefsFiles 4
#define prefsStartup 5

/*** Apple menu constants ***/
#define appleAboutItem 1
#define appleAboutHelpItem 2

/*** File menu constants ***/
#define fileOpenItem 1
#define fileImportItem 2
#define fileCloseItem 3
#define fileCloseAllItem 4
#define fileSaveItem 6
#define fileSlideItem 8
#define fileStartSlideItem 9
#define fileEndSlideItem 10
#define filePageSetupItem 12
#define filePrintItem 13
#define filePrefsItem 15
#define fileQuitItem 17

/*** Edit menu constants ***/
#define editUndoItem 1
#define editCutItem 3
#define editCopyItem 4
#define editPasteItem 5
#define editClearItem 6
#define editSelectScreenItem 8
#define editCropItem 10
#define editUncropItem 11

/*** View menu constants ***/
#define viewFullScreenItem 1
#define viewResizeItem 3
#define viewNormalItem 5
#define viewHalfItem 6
#define viewDoubleItem 7
#define viewMaxItem 8
#define viewShrinkItem 10
#define viewExpandItem 11

/*** Color menu constants ***/
#define colorSysItem 1
#define colorGrayItem 2
#define colorImageItem 3
#define colorQuantItem 4
#define colorDitherItem 6
#define colorQualityItem 8

/*** Window menu constants ***/
#define windowStatItem 1
#define windowCommentsItem 2
#define windowColorsItem 3
#define windowPreviousItem 5
#define windowNextItem 6
#define windowFirstItem 8

/*** About dialog constants ***/
#define aboutUserItem 1
#define aboutLineUser 4

/*** Open dialog constants ***/
#define openScanButton 16

/*** Save dialog constants ***/
#define saveCloseBox 13
#define saveLineUser1 14
#define savePopupMenu 15
#define saveLineUser2 16
#define saveIconsBox 17
#define savePreviewBox 18
#define savePaletteBox 19
#define saveLineUser3 20
#define saveCropMenu 21

/*** Select folder dialog constants ***/
#define folderSelectButton 13

/*** Help dialog constants ***/
#define helpPopUpMenu 1
#define helpTextArea 2
#define helpScrollBar 3

/*** Slide show dialog constants ***/
#define slideBeginButton 1
#define slideOutlineUser 2
#define slideRevertButton 3

#define slideDelayText 4
#define slideDelayEdit 5
#define slideTimePopUpMenu 6
#define slideRandomBox 7
#define slideRepeatBox 8
#define slideIgnoreErrBox 9
#define slideHideWindoidsBox 10
#define slideHideControlsBox 11
#define slideAutoCommentsBox 12
#define slideFilenamesBox 13
#define slideControlMenu 14
#define slideLeftBoxUser 15

#define slideSelectButton 16
#define slideFolderUser 17
#define slideRecursiveBox 18
#define slideImportBox 19
#define slideOffscreenBox 20
#define slideSourceMenu 21
#define slideRightBoxUser 22

/*** Preferences dialog constants ***/
#define prefsFirstWindowsItem 1
#define prefsImageDeepestButton 2
#define prefsImageLargestButton 3
#define prefsImageMainButton 4
#define prefsUseColorBox 5
#define prefsAlwaysFullButton 7
#define prefsAlwaysLargeButton 8
#define prefsAskLargeButton 9
#define prefsNeverFullButton 10
#define prefsExpandSmallBox 11
#define prefsOnlyOneBox 12
#define prefsLastWindowsItem 12

#define prefsFirstDisplayItem 13
#define prefsVHighQualityButton 14
#define prefsHighQualityButton 15
#define prefsMedQualityButton 16
#define prefsBackgroundBox 17
#define prefsQuantizeAlwaysButton 19
#define prefsQuantizeOnlyButton 20
#define prefsQuantizeNeverButton 21
#define prefsDitherQuantizedBox 22
#define prefsUsePaletteBox 23
#define prefsRestoreColorsBox 24
#define prefsLastDisplayItem 24

#define prefsFirstBitmapsItem 25
#define prefsBitmapsAlwaysButton 26
#define prefsBitmapsOptionalButton 27
#define prefsBitmapsNeverButton 28
#define prefsOriginalSizeBox 29
#define prefsNoUncompressedBox 30
#define prefsLastBitmapsItem 30

#define prefsFirstFilesItem 31
#define prefsFixFilesBox 31
#define prefsFixCreatorsBox 32
#define prefsSaveQAlwaysButton 34
#define prefsSaveQOnlyButton 35
#define prefsSaveQNeverButton 36
#define prefsDefaultPICTBox 37
#define prefsSavePreviewsBox 38
#define prefsCompressPreviewsBox 39
#define prefsAddIconsBox 40
#define prefsIconStyleMenu 41
#define prefsLastFilesItem 41

#define prefsFirstMiscItem 42
#define prefsBeginSlidesButton 43
#define prefsSlideDialogButton 44
#define prefsOpenDialogButton 45
#define prefsNothingButton 46
#define prefsAutoCommentsBox 47
#define prefsMaximalBox 49
#define prefsReasonableBox 50
#define prefsMinimalBox 51
#define prefsUseQuickTimeBox 52
#define prefsLastMiscItem 52

#define prefsPopUpMenu 53
#define prefsBoxUser 54

/*** Progress dialog constants ***/
#define progressText 1
#define progressUser 2
#define progressCancel 3
#define progressText2 4

/*** End slide show alert constants ***/
#define endSSContinue 1
#define endSSAbort 2
#define endSSOptions 3

/* General resource defines */
#define rNil ""
#define hmnuBlankItem HMStringItem { rNil, rNil, rNil, rNil }
#define hdlgBlankItem HMStringItem { { 0, 0 }, { 0, 0, 0, 0 }, rNil, rNil, rNil, rNil }
#define res9 reserved, reserved, reserved, reserved, reserved, reserved, reserved, \
		reserved, reserved
#define res12 reserved, reserved, reserved, reserved, reserved, reserved, reserved, \
		reserved, reserved, reserved, reserved, reserved
#define res13 reserved, reserved, reserved, reserved, reserved, reserved, reserved, \
		reserved, reserved, reserved, reserved, reserved, reserved
