/*********************************************************/
/* This source code copyright (c) 1991-2001, Aaron Giles */
/* See the Read Me file for licensing information.       */
/* Contact email: mac@aarongiles.com                     */
/*********************************************************/

#define SystemSevenOrLater 1

#include "SysTypes.r"
#include "Types.r"
#include "BalloonTypes.r"
#include "JPEGView.r.h"

#define dialogHelpOffset 1000

/***********************************************************************/
/************************                      *************************/
/************************      Open Dialog     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rOpenDialog, purgeable) 
{
	HelpMgrVersion, 15, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rOpenDialog + dialogHelpOffset, 1,
			rOpenDialog + dialogHelpOffset, 2,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rOpenDialog + dialogHelpOffset, purgeable)
{
	{
		"To scan for valid image files in the list of files above, click "
			"this button.  If any valid images are found, their file types will be "
			"automatically corrected.",
		"Scans for valid image files in the list of files above.  "
			"Not available because this folder has already been scanned."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Save Dialog     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rSaveDialog, purgeable) 
{
	HelpMgrVersion, 12, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // Close when finished button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSaveDialog + dialogHelpOffset, 1,
			0, 0,
			rSaveDialog + dialogHelpOffset, 2,
			0, 0
		},
		hdlgBlankItem, // UserItem
		HMStringResItem { // PICT Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0,
			0, 0,
			rSaveDialog + dialogHelpOffset, 3,
			rSaveDialog + dialogHelpOffset, 3
		},
		hdlgBlankItem, // UserItem
		HMStringResItem { // Create custom icons Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSaveDialog + dialogHelpOffset, 4,
			0, 0,
			rSaveDialog + dialogHelpOffset, 5,
			0, 0
		},
		HMStringResItem { // Include preview/thumbnail Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSaveDialog + dialogHelpOffset, 6,
			rSaveDialog + dialogHelpOffset, 7,
			rSaveDialog + dialogHelpOffset, 8,
			0, 0
		},
		HMStringResItem { // Save quantized palette information Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSaveDialog + dialogHelpOffset, 9,
			rSaveDialog + dialogHelpOffset, 10,
			rSaveDialog + dialogHelpOffset, 11,
			0, 0
		},
		hdlgBlankItem, // UserItem
		HMStringResItem { // Use selection popup menu
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSaveDialog + dialogHelpOffset, 12,
			rSaveDialog + dialogHelpOffset, 13,
			rSaveDialog + dialogHelpOffset, 12,
			0, 0
		}
	}
};

resource 'STR#' (rSaveDialog + dialogHelpOffset, purgeable)
{
	{
		"To automatically close the image after it has been successfully saved, "
			"click this box.",
		"The image will automatically be closed after it has been successfully "
			"saved.  To leave the image open, click this box.",
		"Use this pop-up menu to select the file format you wish to save this image in.  ",
		"To request custom icons for the new image file, click this box.  Custom "
			"icons, which can be seen in the Finder, serve as miniature previews of "
			"the image file contents.",
		"Custom icons will be created for the new image file.  To save the image "
			"with generic JPEGView icons, click this box.",
		"To request a preview (aka thumbnail) for the new image file, click this "
			"box.  Previews can be seen in any QuickTime-based Open dialog, "
			"including the one in JPEGView.",
		"Creates a preview (aka thumbnail) for the new image file.  Not available "
			"because JPEGView needs QuickTime installed before it can create previews.",
		"A preview (aka thumbnail) will be created for the new image file.  To save "
			"the image without a preview, click this box.",
		"To request that a reduced color set be saved with the new image file, "
			"click this box.  A reduced color set allows images to be opened "
			"quickly, without waiting for two-pass color reduction.",
		"Saves a reduced color set with the new image file.  Not available because "
			"this information can only be included in a JPEG-compressed PICT or JFIF file.",
		"A reduced color set will be saved with the new image file.  To request "
			"that this color set not be saved, click this box.",
		"Use this popup menu to specify what you would like to use the currently selected "
			"area of the image for.",
		"Use this popup menu to specify what you would like to use the currently selected "
			"area of the image for.  Not available because you didnt select anything in "
			"the image before you chose to save."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************     Folder Dialog    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rFolderDialog, purgeable) 
{
	HelpMgrVersion, 14, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // Select Folder Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rFolderDialog + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rFolderDialog + dialogHelpOffset, purgeable)
{
	{
		"To select the displayed folder for the slide show, click this button."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Slide Show Dialog   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rSlideShowDialog, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // Begin Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 1,
			rSlideShowDialog + dialogHelpOffset, 2,
			0, 0,
			0, 0
		},
		hdlgBlankItem, // UserItem
		HMStringResItem { // Revert Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 3,
			0, 0,
			0, 0,
			0, 0
		},
		hdlgBlankItem, // delay text
		HMStringResItem { // EditText box
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 4,
			rSlideShowDialog + dialogHelpOffset, 5,
			0, 0,
			0, 0
		},
		HMStringResItem { // Units pop-up menu
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 6,
			rSlideShowDialog + dialogHelpOffset, 7,
			rSlideShowDialog + dialogHelpOffset, 7
		},
		HMStringResItem { // Display in random order checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 8,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 9,
			0, 0
		},
		HMStringResItem { // Repeat indefinitely checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 10,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 11,
			0, 0
		},
		HMStringResItem { // Ignore any non-fatal errors checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 12,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 13,
			0, 0
		},
		HMStringResItem { // Hide floating windows checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 14,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 15,
			0, 0
		},
		HMStringResItem { // Hide slide show controls checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 16,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 17,
			0, 0
		},
		HMStringResItem { // Automatic comments control checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 18,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 19,
			0, 0
		},
		HMStringResItem { // Display filenames checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 20,
			rSlideShowDialog + dialogHelpOffset, 21,
			rSlideShowDialog + dialogHelpOffset, 22,
			0, 0
		},
		HMStringResItem { // Slide show control menu
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 23,
			rSlideShowDialog + dialogHelpOffset, 23
		},
		hdlgBlankItem, // outline box
		HMStringResItem { // Select slide show folder button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 24,
			rSlideShowDialog + dialogHelpOffset, 25,
			0, 0,
			0, 0
		},
		HMStringResItem { // UserItem
			{ 0, 0 },
			{ -20, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 26,
			rSlideShowDialog + dialogHelpOffset, 26,
			0, 0,
			0, 0
		},
		HMStringResItem { // Scan subfolders recursively checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 27,
			rSlideShowDialog + dialogHelpOffset, 28,
			rSlideShowDialog + dialogHelpOffset, 29,
			0, 0
		},
		HMStringResItem { // Import unrecognized files checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 30,
			rSlideShowDialog + dialogHelpOffset, 31,
			rSlideShowDialog + dialogHelpOffset, 32,
			0, 0
		},
		HMStringResItem { // Render offscreen before display checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideShowDialog + dialogHelpOffset, 33,
			rSlideShowDialog + dialogHelpOffset, 34,
			rSlideShowDialog + dialogHelpOffset, 35,
			0, 0
		},
		HMStringResItem { // Slide source menu
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0,
			0, 0,
			rSlideShowDialog + dialogHelpOffset, 36,
			rSlideShowDialog + dialogHelpOffset, 36
		}
	}
};

resource 'STR#' (rSlideShowDialog + dialogHelpOffset, purgeable)
{
	{
		"To save the changes you made and begin the slide show, click this button.",
		"Saves the changes you made and begins the slide show.  Not available "
			"either because there are no open images for a memory-based slide show, "
			"or because you have not selected a valid disk folder.",
		"To restore the settings to what you had previously, click this button.",
		"Type the number of seconds, minutes, or hours JPEGView should delay "
			"between images here.",
		"Type the number of seconds, minutes, or hours JPEGView should delay "
			"between images.  Not available because you have selected a user-"
			"controlled slide show.",
		"Use this pop-up menu to specify the units of time entered in the box to "
			"the left.  Not available because you have selected a user-controlled "
			"slide show.",
		"Use this pop-up menu to specify the units of time entered in the box to "
			"the left.",
		"To automatically shuffle the order of the slides before each repetition, "
			"click this box.",
		"The order of the slides will be automatically shuffled before each "
			"repetition.  To display the slides in the order they are found, click "
			"this box.",
		"To repeat the slide show over and over until it is explicitly interrupted, "
			"check this box.",
		"The slide show will repeat over and over until it is explicitly "
			"interrupted.  To end the slide show after the first pass through your "
			"slides, click this box.",
		"To ignore any minor errors that occur during the slide show, click this "
			"box.",
		"Any minor errors that occur during the slide show will be ignored.  To "
			"report all errors during the slide show, check this box.",
		"To automatically hide all visible floating windows for the duration of the "
			"slide show, click this box.",
		"All visible floating windows will be hidden for the duration of the slide "
			"show.  To keep the floating windows open during the slide show, click "
			"this box.",
		"To keep the slide show controls window hidden when the slide show starts, "
			"click this box.",
		"The slide show controls window will be invisible when the slide show starts.  "
			"To ensure that the controls are visible from the beginning of the slide "
			"show, click this box.",
		"To automatically display the Comments floating window whenever image "
			"comments are found, click this box.",
		"The Comments floating window will be automatically displayed whenever "
			"image comments are found.  To leave the Comments floating window "
			"alone, click this box.",
		"To display the name of each file in the bottom-right corner of the image, "
			"click this box.",
		"Displays the name of each file in the bottom-right corner of the image.  "
			"Not available because you have selected a slide show from images in "
			"memory.",
		"Displays the name of each file in the bottom-right corner of the image.  To "
			"prevent the names from being displayed, click this box.",
		"Use this pop-up menu to select either a user-controlled slide show or an "
			"automatic slide show.",
		"To choose the folder from which the slide show images will be selected, "
			"click this button.",
		"Allows you to choose the folder from which the slide show images "
			"will be selected.  Not available because you have selected a "
			"slide show from images in memory.",
		"This is the folder from which a disk-based slide show will be run.",
		"To scan not only the folder selected above, but also all enclosed folders, "
			"click this box.",
		"Scans not only the folder selected above, but also all enclosed folders.  "
			"Not available because you have selected a slide show from images in "
			"memory.",
		"The folder selected above will be scanned, in addition to all enclosed "
			"folders, for slide show images.  To prevent any enclosed folders from "
			"being scanned, click this box.",
		"To read every file in the selected folder, regardless of what type the "
			"Finder says it is, click this box.",
		"Reads every file in the selected folder, regardless of what type the "
			"Finder says it is.  Not available because you have selected a slide "
			"show from images in memory.",
		"Every file in the selected folder will be read, regardless of what type "
			"the Finder says it is.  To only read files which the Finder says are "
			"valid, click this box.",
		"To draw the next image offscreen before removing the current image, click "
			"this box.  This option minimizes the transition time between slides, "
			"but may cause long delays between slides.",
		"Draws the next image offscreen before removing the current image.  Not "
			"available because you have selected a slide show from images in memory.",
		"The next image will be drawn offscreen before removing the current image.  "
			"To draw the next image as soon as it is loaded into memory, click this "
			"box.",
		"Use this pop-up menu to select whether the slide show images should come "
			"from those currently in memory or from a folder on a disk."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Preferences Dialog  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rPrefsDialog, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		hdlgBlankItem, // StaticText
		HMStringResItem { // Deepest screen button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 1,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 2,
			0, 0
		},
		HMStringResItem { // Largest screen button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 3,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 4,
			0, 0
		},
		HMStringResItem { // Main screen button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 5,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 6,
			0, 0
		},
		HMStringResItem { // Pick color over B&W checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 7,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 8,
			0, 0
		},
		hdlgBlankItem, // StaticText
		HMStringResItem { // Always button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 9,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 10,
			0, 0
		},
		HMStringResItem { // Always for large images button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 11,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 12,
			0, 0
		},
		HMStringResItem { // Ask first for large images button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 13,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 14,
			0, 0
		},
		HMStringResItem { // Never button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 15,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 16,
			0, 0
		},
		HMStringResItem { // Expand small images checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 17,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 18,
			0, 0
		},
		HMStringResItem { // Only one image checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 901, 19,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 901, 20,
			0, 0
		},
		
		hdlgBlankItem, // StaticText
		HMStringResItem { // V. High quality button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 1,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 2,
			0, 0
		},
		HMStringResItem { // High quality button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 3,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 4,
			0, 0
		},
		HMStringResItem { // Medium quality button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 5,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 6,
			0, 0
		},
		HMStringResItem { // Never update background windows checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 7,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 8,
			0, 0
		},
		hdlgBlankItem, // StaticText
		HMStringResItem { // Always button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 9,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 10,
			0, 0
		},
		HMStringResItem { // Only if no internal palette button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 11,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 12,
			0, 0
		},
		HMStringResItem { // Never button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 13,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 14,
			0, 0
		},
		HMStringResItem { // Dither quantized images checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 15,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 16,
			0, 0
		},
		HMStringResItem { // Use internal palette for other images
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 17,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 18,
			0, 0
		},
		HMStringResItem { // Restore colors after last close checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 902, 19,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 902, 20,
			0, 0
		},
		
		hdlgBlankItem, // StaticText
		HMStringResItem { // Always button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 903, 1,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 903, 2,
			0, 0
		},
		HMStringResItem { // Optional button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 903, 3,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 903, 4,
			0, 0
		},
		HMStringResItem { // Never button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 903, 5,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 903, 6,
			0, 0
		},
		HMStringResItem { // Maintain bitmaps at original size checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 903, 7,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 903, 8,
			0, 0
		},
		HMStringResItem { // Dont create bitmaps for uncompressed images
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 903, 9,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 903, 10,
			0, 0
		},

		HMStringResItem { // Automatically fix incorrect file types checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 1,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 2,
			0, 0
		},
		HMStringResItem { // Fix creators as well checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 3,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 4,
			0, 0
		},
		hdlgBlankItem, // StaticText
		HMStringResItem { // Always button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 5,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 6,
			0, 0
		},
		HMStringResItem { // Only if no other palette button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 7,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 8,
			0, 0
		},
		HMStringResItem { // Only if no other palette button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 9,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 10,
			0, 0
		},
		HMStringResItem { // Use PICT format by default checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 11,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 12,
			0, 0
		},
		HMStringResItem { // Save previews checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 13,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 14,
			0, 0
		},
		HMStringResItem { // Compress preview images checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 15,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 16,
			0, 0
		},
		HMStringResItem { // Create icons checkbox
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 904, 17,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 18,
			0, 0
		},
		HMStringResItem { // Icon style popup menu
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 904, 19,
			rPrefsDialog + dialogHelpOffset + 904, 19
		},
		
		hdlgBlankItem, // StaticText
		HMStringResItem { // Begin slide show button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 1,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 2,
			0, 0
		},
		HMStringResItem { // Slide show options dialog button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 3,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 4,
			0, 0
		},
		HMStringResItem { // Open dialog button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 5,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 6,
			0, 0
		},
		HMStringResItem { // Nothing button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 7,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 8,
			0, 0
		},
		HMStringResItem { // Automatic comments window control
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 9,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 10,
			0, 0
		},
		hdlgBlankItem, // StaticText
		HMStringResItem { // Maximal time to BG apps
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 11,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 12,
			0, 0
		},
		HMStringResItem { // Reasonable time to BG apps
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 13,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 14,
			0, 0
		},
		HMStringResItem { // Minimal time to BG apps
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 15,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 16,
			0, 0
		},
		HMStringResItem { // Use QuickTime to decompress JPEGs
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rPrefsDialog + dialogHelpOffset + 905, 17,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 905, 18,
			0, 0
		},

		HMStringResItem { // Pop-up menu
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0,
			0, 0,
			rPrefsDialog + dialogHelpOffset + 900, 1,
			rPrefsDialog + dialogHelpOffset + 900, 1
		}
	}
};

resource 'STR#' (rPrefsDialog + dialogHelpOffset + 900, purgeable)
{
	{
		"Use this pop-up menu to access other groups of options."
	}
};

resource 'STR#' (rPrefsDialog + dialogHelpOffset + 901, purgeable)
{
	{
		"To open new images on the screen that can display the most colors, click "
			"this button.  This will give the highest-quality color fidelity for "
			"the image.",
		"Opens new images on the screen that can display the most colors.  This "
			"option is selected.",
		"To open new images on the screen that has the largest area in pixels, "
			"click this button.  This will allow images to be displayed at the "
			"largest possible size.",
		"Opens new images on the screen that has the largest area in pixels.  This "
			"option is selected.",
		"To open new images on the screen that has the menubar, click this button.  "
			"This will keep all image windows near the menus, for quicker access.",
		"Opens new images on the screen that has the menubar.  This option is "
			"selected.",
		"To ask that color screens be chosen over B&W/grayscale screens with similar "
			"characteristics, click this box.",
		"Color screens will be chosen over B&W/grayscale screens with similar "
			"characteristics.  To ask that B&W/grayscale screens be chosen over "
			"color screens instead, click this box.",
		"To open all images in a full-screen window, regardless of their size, "
			"click this button.",
		"Opens all images in a full-screen window, regardless of their size.  This "
			"option is selected.",
		"To automatically open images taller than the screen in a full-screen "
			"window without asking, click this button.",
		"Automatically opens images taller than the screen in a full-screen "
			"window without asking.  This option is selected.",
		"To request that you be asked before opening images taller than the screen "
			"in a full-screen window, click this button.",
		"Asks before opening images taller than the screen in a full-screen window.  "
			"This option is selected.",
		"To always open images in a normal window, even if they would benefit from "
			"being displayed in a full-screen window, click this box.",
		"Always opens images in a normal window, even if they would benefit from "
			"being displayed in a full-screen window, click this box.  This option "
			"is selected.",
		"To automatically expand smaller images to their maximum size on the "
			"preferred screen, click this box.",
		"Smaller images are automatically expanded to their maximum size on the "
			"preferred screen.  To keep small images at their natural size, click "
			"this box.",
		"To automatically close all other open images before opening a new image, "
			"click this box.  This helps reduce clutter on the desktop.",
		"All other open images will be automatically closed before opening a new "
			"image.  To keep multiple images open at once, click this box."
	}
};

resource 'STR#' (rPrefsDialog + dialogHelpOffset + 902, purgeable)
{
	{
		"To display images using very high quality, click this button.  This "
			"option only affects images displayed on screens with 256 or more "
			"colors.",
		"Displays images using very high quality.  This option is selected.",
		"To display images using high quality, click this button.  This "
			"option only affects images displayed on screens with 256 or more "
			"colors.",
		"Displays images using high quality.  This option is selected.",
		"To display images using normal quality, click this button.  This "
			"option only affects images displayed on screens with 256 or more "
			"colors.",
		"Displays images using normal quality.  This option is selected.",
		"To prevent slow window updates, when necessary, from being used in windows "
			"behind the active window, click this box.",
		"Slow window updates, when necessary, will only be used in the active "
			"window.  To allow slow window updates in other windows after five "
			"seconds of idle time, click this box.",
		"To perform two-pass color reduction on any applicable image, click this "
			"box.  Only images with Thousands or more colors will be reduced, and "
			"then only to 16 or 256 colors.",
		"Performs two-pass color reduction on any applicable image.  This "
			"option is selected.",
		"To perform two-pass color reduction only on images that have no image "
			"colors defined, click this button.  Only images with Thousands or more "
			"colors will be reduced, and then only to 16 or 256 colors.",
		"Performs two-pass color reduction only on images that have no image "
			"colors defined.  This option is selected.",
		"To prevent two-pass color reduction from being used at all, click this "
			"box.",
		"Prevents two-pass color reduction from being used.  This option is "
			"selected.",
		"To use dithering when displaying images on 256 color displays with "
			"two-pass color reduction, click this box.",
		"Dithering will be used when displaying images on 256 color displays with "
			"two-pass color reduction.  To turn off dithering in this situation, "
			"click this box.",
		"To automatically use the images colors if present, click this box.",
		"The images colors will automatically be used, if present.  To use the "
			"standard set of Finder colors instead, click this box.",
		"To restore the system colors on all monitors whenever the last image is "
			"closed, check this box.",
		"The system colors will be restored on all monitors whenever the last image "
			"is closed.  To leave the colors alone after closing the last image, "
			"click this box."
	}
};

resource 'STR#' (rPrefsDialog + dialogHelpOffset + 903, purgeable)
{
	{
		"To make offscreen bitmaps a requirement for all images, click this button.  "
			"This helps ensure that all image windows will be updated quickly.",
		"Makes offscreen bitmaps a requirement for all images.  This option is "
			"selected.",
		"To make offscreen bitmaps optional, click this button.  This allows you to "
			"enjoy the benefits of fast updates when enough memory is available.",
		"Makes offscreen bitmaps optional.  This option is selected.",
		"To prevent offscreen bitmaps from being used, click this button.  This "
			"means that you will never see the benefits fast window updates.",
		"Prevents offscreen bitmaps from being used.  This option is selected.",
		"To maintain bitmaps at the images original size, click this box.  Original "
			"size bitmaps require more memory and slow down drawing, but speed up "
			"image manipulation.",
		"Offscreen bitmaps will be maintained at the images original size.  To "
			"reduce the size of offscreen bitmaps and to speed up drawing, check "
			"this box.",
		"To prevent the use of offscreen bitmaps for images that are not compressed, "
			"check this box.",
		"Offscreen bitmaps will not be used for images that are not compressed.  To "
			"create offscreen bitmaps for any kind of image, compressed or not, "
			"click this box."
	}
};

resource 'STR#' (rPrefsDialog + dialogHelpOffset + 904, purgeable)
{
	{
		"To quietly fix incorrect file types on any files you open in JPEGView, "
			"click this box.  This ensures proper identification of the image by "
			"the Finder and other applications.",
		"Incorrect file types are automatically fixed when you open a file in "
			"JPEGView.  To prevent this from happening behind your back, click this "
			"box.",
		"To make JPEGView the owner of any files whose types are automatically "
			"fixed, click this box.  This means that the Finder will open JPEGView "
			"when you double-click on the files icon.",
		"JPEGView will become the owner of any files whose types are automatically "
			"fixed.  To retain the files original owner, click this box.",
		"To automatically turn on the Save reduced color set option when saving "
			"images that have been previously reduced, click this button.",
		"Automatically turns on the Save reduced color set option when saving "
			"images that have been previously reduced.  This option is selected.",
		"To turn on the Save reduced color set option only when saving images "
			"that have no image colors, click this button.",
		"Turns on the Save reduced color set option only when saving images that "
			"have no image colors.  This option is selected.",
		"To always leave the Save reduced color set option off when saving "
			"images, click this button.",
		"Leaves the Save reduced color set option off when saving images.  This "
			"option is selected.",
		"To automatically set the output file type to PICT when saving an image, "
			"regardless of which format the image was originally stored in, click "
			"this box.",
		"The output file type will automatically be set to PICT when saving an "
			"image.  To keep the file format the same as it originally was, click "
			"this box.",
		"To automatically turn on the Include preview image option when saving "
			"PICT and JFIF images, click this box.",
		"The Include preview image option will automatically be turned on when "
			"saving PICT and JFIF images.  To leave the previews option off, click "
			"this box.",
		"To compress previews created when saving JFIF images, click this box.  "
			"This saves space in the JFIF file at the expense of the previews "
			"image quality.",
		"Previews created when saving JFIF images will be compressed.  To leave "
			"previews uncompressed, click this box.",
		"To automatically turn on the Create custom icons option when saving "
			"images, click this box.",
		"The Create custom icons option will be automatically turned on when "
			"saving images.  To leave the custom icons option off, click this box.",
		"Use this pop-up menu to select the icon style you prefer."
	}
};

resource 'STR#' (rPrefsDialog + dialogHelpOffset + 905, purgeable)
{
	{
		"To automatically start up the slide show with the last set of saved "
			"settings, click this button.",
		"Automatically starts up the slide show with the last set of saved "
			"settings.  This option is selected.",
		"To bring up the Slide Show Options dialog when JPEGView starts, click "
			"this button.",
		"Brings up the Slide Show Options dialog when JPEGView starts.  This option "
			"is selected.",
		"To bring up the Open dialog when JPEGView starts, click this button.",
		"Brings up the Open dialog when JPEGView starts.  This option is selected.",
		"To do nothing when JPEGView starts, click this button.",
		"Does nothing when JPEGView starts.  This option is selected.",
		"To automatically display the Comments floating window whenever the active "
			"image contains comments, click this box.",
		"The Comments floating window will automatically be displayed whenever the "
			"active image contains comments.  To leave the comments under user "
			"control, click this box.",
		"To give other applications a lot of processor time while JPEGView is "
			"decompressing images, click this button.  This option will certainly "
			"slow down JPEGViews operations.",
		"Gives other applications a lot of processor time while JPEGView is "
			"decompressing images.  This option is selected.",
		"To give other applications a reasonable amount of processor time while "
			"JPEGView is decompressing images, click this button.",
		"Gives other applications a reasonable amount of processor time while "
			"JPEGView is decompressing images.  This option is selected.",
		"To give other applications very little processor time while JPEGView is "
			"decompressing images, click this button.  This option will cause "
			"other applications to slow down greatly.",
		"Gives other applications very little processor time while JPEGView is "
			"decompressing images.  This option is selected.",
		"To use QuickTime for displaying JPEG-compressed images, check this box.  "
			"On non-PowerPC Macintoshes, this option usually speeds up JPEG "
			"decompression.",
		"To use the Independent JPEG Groups (IJG) code for decompressing JPEG images, "
			"uncheck this box.  The IJG code is more robust and less prone to "
			"crashing on damaged JPEG images."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Minor Alert     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rMinorAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // OK Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rMinorAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rMinorAlert + dialogHelpOffset, purgeable)
{
	{
		"To continue, click this button."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Fatal Alert     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rFatalAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // OK Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rFatalAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rFatalAlert + dialogHelpOffset, purgeable)
{
	{
		"To return to the Finder, click this button.  There is no way to return "
			"to JPEGView without starting over."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************     Unknown Alert    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rUnknownAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // OK Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rUnknownAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rUnknownAlert + dialogHelpOffset, purgeable)
{
	{
		"To continue, click this button.  Please report this error to the author "
			"as soon as possible.  In the meantime, proceed with caution."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************   End Slides Alert   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rEndSlidesAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // OK Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rEndSlidesAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rEndSlidesAlert + dialogHelpOffset, purgeable)
{
	{
		"To return to JPEGViews normal mode of operations, click this button."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Slide Memory Alert  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rSlideMemAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // Continue Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideMemAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		},
		hdlgBlankItem, // Static text
		HMStringResItem { // Abort Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideMemAlert + dialogHelpOffset, 2,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rSlideMemAlert + dialogHelpOffset, purgeable)
{
	{
		"To proceed, even though the slide show will be incomplete, click this "
			"button.",
		"To abort the slide show immediately, click this button."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************     Too Big Alert    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rTooBigAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // Yes Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rTooBigAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		},
		hdlgBlankItem, // Static text
		HMStringResItem { // No Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rTooBigAlert + dialogHelpOffset, 2,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rTooBigAlert + dialogHelpOffset, purgeable)
{
	{
		"To use a full-screen window for the image, click this button.",
		"To resort to a standard-size window for the image, click this button."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************    Bad JPEG Alert    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hdlg' (rBadJPEGAlert, purgeable) 
{
	HelpMgrVersion, 0, hmDefaultOptions, 0, 0, 
	hdlgBlankItem, // Defaults
	{
		HMStringResItem { // OK Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rBadJPEGAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		},
		hdlgBlankItem, // Static text
		HMStringResItem { // Cancel Button
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rBadJPEGAlert + dialogHelpOffset, 1,
			0, 0,
			0, 0,
			0, 0
		}
	}
};

resource 'STR#' (rBadJPEGAlert + dialogHelpOffset, purgeable)
{
	{
		"To proceed with viewing the image, click this button.",
		"To abort the viewing of the image, click this button."
	}
};
