/*********************************************************/
/* This source code copyright (c) 1991-2001, Aaron Giles */
/* See the Read Me file for licensing information.       */
/* Contact email: mac@aarongiles.com                     */
/*********************************************************/

#define SystemSevenOrLater 1

#include "SysTypes.r"
#include "Types.r"
#include "BalloonTypes.r"
#include "JPEGView.r.h"

#define dialogHelpOffset 1000

/***********************************************************************/
/************************                      *************************/
/************************      Open Dialog     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rOpenDialog, preload) 
{
	{ 0, 0, 208, 447 },
	dBoxProc, invisible, noGoAway, kOpenDialogID, rOpenDialog, "",
	noAutoCenter
};

resource 'dctb' (rOpenDialog, preload)
{
	{ }, { }
};

resource 'DITL' (rOpenDialog, preload) 
{
	{
		{ 135, 355, 155, 435 },
			Button { enabled, "Open" },
		{ 104, 355, 124, 435 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { -6042 } },
		{ 8, 340, 24, 442 },
			UserItem { enabled },
		{ 32, 355, 52, 435 },
			Button { enabled, "Eject" },
		{ 60, 355, 80, 435 },
			Button { enabled, "Desktop" },
		{ 29, 118, 159, 336 },
			UserItem { enabled },
		{ 6, 118, 25, 336 },
			UserItem { enabled },
		{ 91, 354, 92, 436 },
			Picture { disabled, 11 },
		{ 1043, 122, 1144, 218 },
			StaticText { disabled, "" },
		{ 39, 5, 139, 105 },
			UserItem { enabled },
		{ 18, 27, 34, 84 },
			StaticText { disabled, "Preview" },
		{ 29, 110, 174, 111 },
			UserItem { disabled },
		{ 143, 15, 163, 95 },
			Button { enabled, "Create" },
		{ 161, 118, 181, 234 },
			CheckBox { enabled, "Show Preview" },
		{ 184, 118, 204, 336 },
			Button { enabled, "Scan for Image Files" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rOpenDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Small Open Dialog   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rOpenDialogNoQT, preload) 
{
	{ 0, 0, 188, 344 },
	dBoxProc, invisible, noGoAway, kOpenDialogID, rOpenDialogNoQT, "",
	noAutoCenter
};

resource 'dctb' (rOpenDialogNoQT, preload)
{
	{ }, { }
};

resource 'DITL' (rOpenDialogNoQT, preload) 
{
	{
		{ 135, 252, 155, 332 },
			Button { enabled, "Open" },
		{ 104, 252, 124, 332 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { -6042 } },
		{ 8, 235, 24, 337 },
			UserItem { enabled },
		{ 32, 252, 52, 332 },
			Button { enabled, "Eject" },
		{ 60, 252, 80, 332 },
			Button { enabled, "Desktop" },
		{ 29, 12, 159, 230 },
			UserItem { enabled },
		{ 6, 12, 25, 230 },
			UserItem { enabled },
		{ 91, 251, 92, 333 },
			Picture { disabled, 11 },
		{ 1043, 122, 1144, 218 },
			StaticText { disabled, "" },
		{ 1039, 5, 1139, 105 },
			UserItem { disabled },
		{ 1018, 27, 1034, 84 },
			StaticText { disabled, "Preview" },
		{ 1029, 110, 1174, 111 },
			UserItem { disabled },
		{ 1143, 15, 1163, 95 },
			Button { disabled, "Create" },
		{ 1161, 118, 1181, 234 },
			CheckBox { disabled, "Show Preview" },
		{ 164, 15, 184, 233 },
			Button { enabled, "Scan for Image Files" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rOpenDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Save Dialog     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rSaveDialog, preload) 
{
	{ 0, 0, 326, 344 },
	dBoxProc, invisible, noGoAway, kSaveDialogID, rSaveDialog, "",
	noAutoCenter
};

resource 'CNTL' (rSavePopupControl, preload) 
{
	{ 208, 9, 228, 310 },
	popupTitleRightJust, visible, 150, rSaveMenu, popupMenuCDEFProc + popupFixedWidth, 0, 
		"Output file format: "
};

resource 'CNTL' (rCropPopupControl, preload) 
{
	{ 302, 9, 322, 285 },
	popupTitleRightJust, visible, 175, rCropMenu, popupMenuCDEFProc + popupFixedWidth, 0, 
		"Use selection to crop: "
};

resource 'dctb' (rSaveDialog, preload)
{
	{ }, { }
};

resource 'DITL' (rSaveDialog, preload)
{
	{
		{ 161, 252, 181, 332 },
			Button { enabled, "Save" },
		{ 130, 252, 150, 332 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { -6043	} },
		{ 8, 235, 24, 337 },
			UserItem { enabled },
		{ 32, 252, 52, 332 },
			Button { enabled, "Eject" },
		{ 60, 252, 80, 332 },
			Button { enabled, "Desktop" },
		{ 29, 12, 127, 230 },
			UserItem { enabled },
		{ 6, 12, 25, 230 },
			UserItem { enabled },
		{ 119, 250, 120, 334 },
			Picture { disabled, 11 },
		{ 157, 15, 173, 227 },
			EditText { enabled, "" },
		{ 136, 15, 152, 227 },
			StaticText { disabled, "Save as:" },
		{ 88, 252, 108, 332 },
			UserItem { disabled },
		{ 180, 42, 198, 198 },
			CheckBox { enabled, "Close when finished" },
		{ 201, 9, 202, 333 },
			UserItem { disabled },
		{ 208, 9, 228, 310 },
			Control { enabled, rSavePopupControl },
		{ 233, 9, 234, 333 },
			UserItem { disabled },
		{ 237, 42, 255, 298 },
			CheckBox { enabled, "Create custom Finder icons" },
		{ 255, 42, 273, 298 },
			CheckBox { enabled, "Create QuickTime preview" },
		{ 273, 42, 291, 298 },
			CheckBox { enabled, "Remember reduced color set" },
		{ 294, 9, 295, 333 },
			UserItem { disabled },
		{ 301, 9, 321, 285 },
			Control { enabled, rCropPopupControl },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rSaveDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Simple Save Dialog  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rSimpleSaveDialog, preload) 
{
	{ 0, 0, 294, 344 },
	dBoxProc, invisible, noGoAway, kSaveDialogID, rSimpleSaveDialog, "",
	noAutoCenter
};

resource 'dctb' (rSimpleSaveDialog, preload)
{
	{ }, { }
};

resource 'DITL' (rSimpleSaveDialog, preload)
{
	{
		{ 161, 252, 181, 332 },
			Button { enabled, "Save" },
		{ 130, 252, 150, 332 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { -6043	} },
		{ 8, 235, 24, 337 },
			UserItem { enabled },
		{ 32, 252, 52, 332 },
			Button { enabled, "Eject" },
		{ 60, 252, 80, 332 },
			Button { enabled, "Desktop" },
		{ 29, 12, 127, 230 },
			UserItem { enabled },
		{ 6, 12, 25, 230 },
			UserItem { enabled },
		{ 119, 250, 120, 334 },
			Picture { disabled, 11 },
		{ 157, 15, 173, 227 },
			EditText { enabled, "" },
		{ 136, 15, 152, 227 },
			StaticText { disabled, "Save as:" },
		{ 88, 252, 108, 332 },
			UserItem { disabled },
		{ 180, 42, 198, 198 },
			CheckBox { enabled, "Close when finished" },
		{ 201, 9, 202, 333 },
			UserItem { disabled },
		{ 1208, 1009, 1228, 1310 },
			Control { enabled, rSavePopupControl },
		{ 1232, 1009, 1233, 1333 },
			UserItem { disabled },
		{ 205, 42, 223, 298 },
			CheckBox { enabled, "Create custom Finder icons" },
		{ 223, 42, 241, 298 },
			CheckBox { enabled, "Create QuickTime preview" },
		{ 241, 42, 259, 298 },
			CheckBox { enabled, "Remember reduced color set" },
		{ 262, 9, 263, 333 },
			UserItem { disabled },
		{ 269, 9, 289, 285 },
			Control { enabled, rCropPopupControl },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rSaveDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************     Folder Dialog    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rFolderDialog, preload) 
{
	{ 0, 0, 215, 344 },
	dBoxProc, invisible, noGoAway, kFolderDialogID, rFolderDialog, "",
	noAutoCenter
};

resource 'dctb' (rFolderDialog, preload)
{
	{ }, { }
};

resource 'DITL' (rFolderDialog, preload) 
{
	{
		{ 157, 253, 177, 333 },
			Button { enabled, "Open" },
		{ 126, 253, 146, 333 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { -6042 } },
		{ 30, 236, 46, 338 },
			UserItem { enabled },
		{ 54, 253, 74, 333 },
			Button { enabled, "Eject" },
		{ 82, 253, 102, 333 },
			Button { enabled, "Desktop" },
		{ 51, 13, 181, 231 },
			UserItem { enabled },
		{ 28, 13, 47, 231 },
			UserItem { enabled },
		{ 113, 252, 114, 334 },
			Picture { disabled, 11 },
		{ 1157, 1015, 1173, 1227 },
			StaticText { disabled, "" },
		{ 1136, 1015, 1152, 1227 },
			StaticText { disabled, "Save as:" },
		{ 1088, 1252, 1108, 1332 },
			UserItem { disabled },
		{ 189, 24, 209, 211 },
			Button { enabled, "" },
		{ 6, 15, 23, 128 },
			StaticText { disabled, "Select a folder:" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rFolderDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Slide Show Dialog   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rSlideShowDialog, preload) 
{
	{ 0, 0, 232, 510 },
	noGrowDocProc, invisible, goAway, kSlideShowDialogID, rSlideShowDialog, 
	"JPEGView Slide Show Options",
	noAutoCenter
};

resource 'dctb' (rSlideShowDialog, preload)
{
	{ }, { }
};

resource 'CNTL' (rSlideControlMenuControl, preload) 
{
	{ 13, 30, 33, 200 },
	popupTitleLeftJust, visible, 0, rSlideControlMenu, popupMenuCDEFProc + popupFixedWidth, 0, 
		""
};

resource 'CNTL' (rSlideSourceMenuControl, preload) 
{
	{ 13, 272, 33, 452 },
	popupTitleLeftJust, visible, 0, rSlideSourceMenu, popupMenuCDEFProc + popupFixedWidth, 0, 
		""
};

resource 'CNTL' (rTimeMenuControl, preload) 
{
	{ 43, 130, 63, 225 },
	popupTitleLeftJust, visible, 0, rTimeMenu, popupMenuCDEFProc, 0, ""
};

resource 'DITL' (rSlideShowDialog, preload) 
{
	{
		{ 194, 417, 214, 492 },
			Button { enabled, "Begin" },
		{ 189, 412, 219, 497 },
			UserItem { disabled },
		{ 194, 332, 214, 407 },
			Button { enabled, "Revert" },

		{ 45, 23, 61, 70 },
			StaticText { disabled, "Delay:" },
		{ 45, 80, 61, 120 },
			EditText { enabled, "15" },
		{ 43, 130, 63, 225 },
			Control { enabled, rTimeMenuControl },
		{ 83, 13, 101, 245 },
			CheckBox { enabled, "Display in random order" },
		{ 101, 13, 119, 245 },
			CheckBox { enabled, "Repeat indefinitely" },
		{ 119, 13, 137, 245 },
			CheckBox { enabled, "Ignore minor errors" },
		{ 147, 13, 165, 245 },
			CheckBox { enabled, "Hide floating windows" },
		{ 165, 13, 183, 245 },
			CheckBox { enabled, "Hide slide show controls" },
		{ 183, 13, 201, 245 },
			CheckBox { enabled, "Automatically show comments" },
		{ 201, 13, 219, 245 },
			CheckBox { enabled, "Display filenames" },
		{ 13, 30, 33, 200 },
			Control { enabled, rSlideControlMenuControl },
		{ 23, 13, 73, 245 },
			UserItem { disabled },

		{ 43, 265, 63, 487 },
			Button { enabled, "Select Slide Show Folder" },
		{ 73, 265, 91, 487 },
			UserItem { disabled },
		{ 101, 265, 119, 487 },
			CheckBox { enabled, "Scan subfolders recursively" },
		{ 119, 265, 137, 487 },
			CheckBox { enabled, "Import unrecognized files" },
		{ 137, 265, 155, 487 },
			CheckBox { enabled, "Decompress offscreen" },
		{ 13, 272, 33, 452 },
			Control { enabled, rSlideSourceMenuControl },
		{ 23, 255, 165, 497 },
			UserItem { disabled },

		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rSlideShowDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Preferences Dialog  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rPrefsDialog, preload) 
{
	{ 0, 0, 309, 396 },
	noGrowDocProc, invisible, goAway, kPrefsDialogID, rPrefsDialog, 
	"JPEGView Preferences",
	noAutoCenter
};

resource 'CNTL' (rPrefsMenuControl, preload) 
{
	{ 13, 30, 33, 203 },
	popupTitleLeftJust, visible, 0, rPrefsMenu, popupMenuCDEFProc + popupFixedWidth, 0, 
		""
};

resource 'CNTL' (rIconPopupControl, preload) 
{
	{ 13, 23, 53, 373 },
	popupTitleLeftJust, visible, 100, rIconMenu, popupMenuCDEFProc + popupFixedWidth, 0, 
		"Icon Style:"
};

resource 'dctb' (rPrefsDialog, preload)
{
	{ }, { }
};

/*

New Preferences resources:
Array of strings; layout determined on the fly
First character determines type:
   ! Static text
   . Radio button
   / Checkbox
   $ Edit text?

resource 'STR#' (rOpenPrefs, preload)
{
	{
		"!Open new images on the:",
		".Deepest screen",
		".Largest screen",
		".Main (menubar) screen",
		"/Color screens preferred",
		"!Use full screen windows for new images:",
		".Always",
		".Always for large images",
		".Ask first for large images",
		".Never, even for large images",
		"/Expand small images to maximum size",
		"/Allow only one open image at a time"
	}
};

*/

resource 'DITL' (rPrefsDialog, preload) 
{
	{
		{ 40, 23, 58, 373 },
			StaticText { disabled, "Open new images on the:" },
		{ 58, 43, 76, 353 },
			RadioButton { enabled, "Deepest screen" },
		{ 76, 43, 94, 353 },
			RadioButton { enabled, "Largest screen" },
		{ 94, 43, 112, 353 },
			RadioButton { enabled, "Main (menubar) screen" },
		{ 122, 23, 140, 373 },
			CheckBox { enabled, "Color screens preferred" },
		{ 150, 23, 168, 373 },
			StaticText { disabled, "Use full screen windows for new images:" },
		{ 168, 43, 186, 353 },
			RadioButton { enabled, "Always" },
		{ 186, 43, 204, 353 },
			RadioButton { enabled, "Always for large images" },
		{ 204, 43, 222, 353 },
			RadioButton { enabled, "Ask first for large images" },
		{ 222, 43, 240, 353 },
			RadioButton { enabled, "Never, even for large images" },
		{ 250, 23, 268, 373 },
			CheckBox { enabled, "Expand small images to maximum size" },
		{ 268, 23, 286, 373 },
			CheckBox { enabled, "Allow only one open image at a time" },

		{ 40, 23, 58, 373 },
			StaticText { disabled, "Display quality (screens with 256 or more colors):" },
		{ 58, 43, 76, 353 },
			RadioButton { enabled, "Very high" },
		{ 76, 43, 94, 353 },
			RadioButton { enabled, "High" },
		{ 94, 43, 112, 353 },
			RadioButton { enabled, "Normal" },
		{ 122, 23, 140, 373 },
			CheckBox { enabled, "Never do slow background updates" },
		{ 150, 23, 168, 373 },
			StaticText { disabled, "Automatically reduce images to 16 or 256 colors:" },
		{ 168, 43, 186, 353 },
			RadioButton { enabled, "Always, if appropriate" },
		{ 186, 43, 204, 353 },
			RadioButton { enabled, "Only if no image colors are found" },
		{ 204, 43, 222, 353 },
			RadioButton { enabled, "Never" },
		{ 232, 23, 250, 373 },
			CheckBox { enabled, "Dither reduced color images " },
		{ 250, 23, 268, 373 },
			CheckBox { enabled, "Use image colors, if available" },
		{ 268, 23, 286, 373 },
			CheckBox { enabled, "Restore colors when closing last image" },
			
		{ 40, 23, 58, 373 },
			StaticText { disabled, "Offscreen bitmaps are:" },
		{ 58, 43, 76, 353 },
			RadioButton { enabled, "Always required" },
		{ 76, 43, 94, 353 },
			RadioButton { enabled, "Optional, if memory is available" },
		{ 94, 43, 112, 353 },
			RadioButton { enabled, "Never created" },
		{ 122, 23, 140, 373 },
			CheckBox { enabled, "Maintain bitmaps at images original size" },
		{ 140, 23, 158, 373 },
			CheckBox { enabled, "Dont use bitmaps for uncompressed images" },
		
		{ 40, 23, 58, 373 },
			CheckBox { enabled, "Automatically fix incorrect file types" },
		{ 58, 23, 76, 373 },
			CheckBox { enabled, "Change fixed files creator to JPEGView" },
		{ 86, 23, 104, 373 },
			StaticText { disabled, "Save reduced color information:" },
		{ 104, 43, 122, 353 },
			RadioButton { enabled, "Always" },
		{ 122, 43, 140, 353 },
			RadioButton { enabled, "Only if no image colors were found" },
		{ 140, 43, 158, 353 },
			RadioButton { enabled, "Never" },
		{ 168, 23, 186, 373 },
			CheckBox { enabled, "Save JPEGs in PICT format by default" },
		{ 186, 23, 204, 373 },
			CheckBox { enabled, "Include previews with saved images" },
		{ 204, 23, 222, 373 },
			CheckBox { enabled, "Compress JFIF preview images" },
		{ 222, 23, 240, 373 },
			CheckBox { enabled, "Create custom icons when saving images" },
		{ 248, 23, 288, 373 },
			Control { enabled, rIconPopupControl },
			
		{ 40, 23, 58, 373 },
			StaticText { disabled, "On startup:" },
		{ 58, 43, 76, 353 },
			RadioButton { enabled, "Repeat the last slide show" },
		{ 76, 43, 94, 353 },
			RadioButton { enabled, "Present the Slide Show Options dialog" },
		{ 94, 43, 112, 353 },
			RadioButton { enabled, "Present the Open dialog" },
		{ 112, 43, 130, 353 },
			RadioButton { enabled, "Do nothing" },
		{ 140, 23, 158, 373 },
			CheckBox { enabled, "Automatic comments window control" },
		{ 168, 23, 186, 373 },
			StaticText { disabled, "Time given to other applications:" },
		{ 186, 43, 204, 353 },
			RadioButton { enabled, "Maximal" },
		{ 204, 43, 222, 353 },
			RadioButton { enabled, "Reasonable" },
		{ 222, 43, 240, 353 },
			RadioButton { enabled, "Minimal" },
		{ 250, 23, 268, 373 },
			CheckBox { enabled, "Use QuickTime to decompress JPEGs" },
		
		{ 13, 30, 33, 203 },
			Control { enabled, rPrefsMenuControl },
 		{ 23, 13, 296, 383 },
 			UserItem { disabled },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rPrefsDialog } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************   About Help Dialog  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rAboutHelpDialog, preload) 
{
	{ 0, 0, 143, 264 },
	noGrowDocProc, invisible, goAway, kAboutHelpDialogID, rAboutHelpDialog, 
		"About JPEGView Help",
	noAutoCenter
};

resource 'DITL' (rAboutHelpDialog, preload) 
{
	{
		{ 13, 10, 130, 254 },
			Picture { disabled, rAboutHelpPict },
	}
};

/***********************************************************************/
/************************                      *************************/
/************************    Progress Dialog   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'DLOG' (rProgressDialog, preload) 
{
	{ 0, 0, 75, 300 },
	movableDBoxProc, invisible, noGoAway, kProgressDialogID, rProgressDialog, "JPEGView Progress",
	noAutoCenter
};

resource 'dctb' (rProgressDialog, preload)
{
	{ }, { }
//#ifndef oldTemp
//	,{ }
//#endif
};

resource 'DITL' (rProgressDialog, preload) 
{
	{
		{ 7, 10, 23, 290 },
			StaticText { disabled, "^0:" },
		{ 50, 10, 60, 205 },
			UserItem { disabled },
		{ 45, 215, 65, 290 },
			Button { enabled, "Cancel" },
		{ 25, 10, 41, 290 },
			StaticText { disabled, "^3" },
	}
};

/***********************************************************************/
/***********************                       *************************/
/*********************** Modal Progress Dialog *************************/
/***********************                       *************************/
/***********************************************************************/

resource 'DLOG' (rModalProgressDialog, preload) 
{
	{ 0, 0, 75, 300 },
	dBoxProc, invisible, noGoAway, kProgressDialogID, rModalProgressDialog, "JPEGView Progress",
	noAutoCenter
};

resource 'dctb' (rModalProgressDialog, preload)
{
	{ }, { }
//#ifndef oldTemp
//	,{ }
//#endif
};

resource 'DITL' (rModalProgressDialog, preload) 
{
	{
		{ 7, 10, 23, 290 },
			StaticText { disabled, "^0:" },
		{ 50, 10, 60, 205 },
			UserItem { disabled },
		{ 45, 215, 65, 290 },
			Button { enabled, "Cancel" },
		{ 25, 10, 41, 290 },
			StaticText { disabled, "^3" },
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Minor Alert     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rMinorAlert, preload) 
{
	{ 0, 0, 105, 310 },
	rMinorAlert, beepStages,
	noAutoCenter
};

resource 'DITL' (rMinorAlert, preload) 
{
	{
		{ 75, 225, 95, 300 },
			Button { enabled, "OK" },
		{ 8, 75, 65, 300 },
			StaticText { disabled, "Error:  ^0" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rMinorAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Fatal Alert     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rFatalAlert, preload) 
{
	{ 0, 0, 105, 310 },
	rFatalAlert, beepStages,
	noAutoCenter
};

resource 'DITL' (rFatalAlert, preload) 
{
	{
		{ 75, 225, 95, 300 },
			Button { enabled, "Finder" },
		{ 8, 75, 65, 300 },
			StaticText { disabled, "Fatal Error:  ^0" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rFatalAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************     Unknown Alert    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rUnknownAlert, preload) 
{
	{ 0, 0, 105, 310 },
	rUnknownAlert, beepStages,
	noAutoCenter
};

resource 'DITL' (rUnknownAlert, preload) 
{
	{
		{ 75, 225, 95, 300 },
			Button { enabled, "OK" },
		{ 8, 75, 65, 300 },
			StaticText { disabled, "Hey!  This wasnt supposed to happen!  Unknown "
									"Error #^0.  Proceed with caution." },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rFatalAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************   End Slides Alert   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rEndSlidesAlert, preload) 
{
	{ 0, 0, 105, 310 },
	rEndSlidesAlert, beepStages,
	noAutoCenter
};

resource 'DITL' (rEndSlidesAlert, preload) 
{
	{
		{ 75, 225, 95, 300 },
			Button { enabled, "OK" },
		{ 8, 75, 65, 300 },
			StaticText { disabled, "The slide show has ended." },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rEndSlidesAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Slide Memory Alert  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rSlideMemAlert, preload) 
{
	{ 0, 0, 115, 310 },
	rSlideMemAlert, beepStages,
	noAutoCenter
};

resource 'DITL' (rSlideMemAlert, preload) 
{
	{
		{ 85, 225, 105, 300 },
			Button { enabled, "OK" },
		{ 8, 75, 75, 300 },
			StaticText { disabled,
				"There is not enough memory to display all the selected "
				"images; proceeding from here will result in an incomplete "
				"slide show."
			},
		{ 85, 140, 105, 215 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rSlideMemAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************     Too Big Alert    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rTooBigAlert, preload) 
{
	{ 0, 0, 115, 310 },
	rTooBigAlert, silentStages,
	noAutoCenter
};

resource 'DITL' (rTooBigAlert, preload) 
{
	{
		{ 85, 225, 105, 300 },
			Button { enabled, "Full" },
		{ 8, 10, 75, 300 },
			StaticText { disabled,
				"The image ^1 is too large to fit in an onscreen window without "
				"scaling.  Do you want to open it in a full screen window?"
			},
		{ 85, 140, 105, 215 },
			Button { enabled, "Normal" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rTooBigAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************    Bad JPEG Alert    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rBadJPEGAlert, preload) 
{
	{ 0, 0, 135, 310 },
	rBadJPEGAlert, silentStages,
	noAutoCenter
};

resource 'DITL' (rBadJPEGAlert, preload) 
{
	{
		{ 105, 225, 125, 300 },
			Button { enabled, "OK" },
		{ 8, 75, 95, 300 },
			StaticText { disabled,
				"The JPEG image ^1 appears to be corrupt, and may cause QuickTime to "
					"crash your system.  Do you still wish to try viewing it?"
			},
		{ 105, 140, 125, 215 },
			Button { enabled, "Cancel" },
		{ 0, 0, 0, 0 },
			HelpItem { disabled, HMScanhdlg { rTooBigAlert } }
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Needs 68020 Alert   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rNeeds68020Alert, preload) 
{
	{ 125, 101, 230, 411 },
	rNeeds68020Alert, beepStages,
	noAutoCenter
};

resource 'DITL' (rNeeds68020Alert, preload) 
{
	{
		{ 75, 225, 95, 300 },
			Button { enabled, "Finder" },
		{ 8, 75, 65, 300 },
			StaticText { disabled, "Fatal Error:  JPEGView requires a 68020 or "
								   "better processor to run!" },
	}
};

/***********************************************************************/
/************************                      *************************/
/************************  Needs Sys 7 Alert   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'ALRT' (rNeedsSystem7Alert, preload) 
{
	{ 125, 101, 230, 411 },
	rNeedsSystem7Alert, beepStages,
	noAutoCenter
};

resource 'DITL' (rNeedsSystem7Alert, preload) 
{
	{
		{ 75, 225, 95, 300 },
			Button { enabled, "Finder" },
		{ 8, 75, 65, 300 },
			StaticText { disabled, "Fatal Error:  JPEGView requires System 7 or "
								   "later to run!" },
	}
};
