/*********************************************************/
/* This source code copyright (c) 1991-2001, Aaron Giles */
/* See the Read Me file for licensing information.       */
/* Contact email: mac@aarongiles.com                     */
/*********************************************************/

/*
 * JPEGView resource definition file
 *
 */

#define SystemSevenOrLater 1

#include "SysTypes.r"
#include "Types.r"
#include "BalloonTypes.r"
#include "JPEGView.r.h"

#define generalHelpOffset 3000

/***********************************************************************/
/*******************                              **********************/
/*******************       Statistics Window      **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'hrct' (rStatWindow, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 1
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 2
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 3
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 4
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 5
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 6
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 7
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 8
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 9
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 10
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 11
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 12
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 13
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 14
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 15
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rStatWindow + generalHelpOffset, 16
		}
	}
};

resource 'STR#' (rStatWindow + generalHelpOffset, purgeable)
{
	{
		"Statistics floating window\n\n"
			"This floating window gives a brief list of information about the "
			"active image.  Click the zoom box on the right side of the title bar "
			"for more detailed information.",
		"JPEGView credits\n\n"
			"Just like in the movies!  Sit back, eat your popcorn, and find out "
			"who (and what) made it all happen.",
		"Statistics floating window\n\n"
			"This floating window lists information about the "
			"active image.  Click the zoom box on the right side of the title bar "
			"to shrink the information to a one-line summary.",
		"This is the name of the file that the active image was read from.",
		"This is size of the active image, given as horizontal pixels x vertical "
			"pixels.  If the image has been cropped, the original size of the image "
			"is displayed as well, in the same format.",
		"This is number of colors contained in the active image.",
		"This is the status of the active image.  Images can be Aborted "
			"(interrupted while drawing), Banded (in several pieces), Cropped "
			"(part of a larger image), or Corrupt (bad data).",
		"This is the compression method used on the active image.  QuickTime-"
			"compressed PICT files and some JPEG images will also display an "
			"indication of the quality used in compression.",
		"This is the data format that was read from the active images original file.",
		"This is the length of the image data, in kilobytes (K).",
		"This is the size of the window used to display the active image.  If this "
			"size is not equal to the original images size, the amount of scaling "
			"is given as a percent (or as horizontal %/vertical %).",
		"This is the set of colors currently selected to use for displaying the "
			"active image.  If dithering has been disabled, it is indicated here as "
			"well.",
		"This is the quality level used when drawing the active image.",
		"This is the amount of time, in seconds, needed to decompress and display "
			"the image from the original data.",
		"This is the size, in kilobytes (K), of the offscreen bitmap used to do "
			"fast window updating.",
		"This is the amount of free memory remaining, in kilobytes (K)."
	}
};

/***********************************************************************/
/*******************                              **********************/
/*******************        Comments window       **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'hrct' (rCommentsWindow, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rCommentsWindow + generalHelpOffset, 1
		}
	}
};

resource 'STR#' (rCommentsWindow + generalHelpOffset, purgeable)
{
	{
		"Comments floating window\n\n"
			"This window displays any text comments that were found included with "
			"the active image."
	}
};

/***********************************************************************/
/*******************                              **********************/
/*******************         Colors window        **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'hrct' (rColorsWindow, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rColorsWindow + generalHelpOffset, 1
		}
	}
};

resource 'STR#' (rColorsWindow + generalHelpOffset, purgeable)
{
	{
		"Colors floating window\n\n"
			"This window displays a sampling of the colors that this screen is "
			"currently set up to display."
	}
};

/***********************************************************************/
/*******************                              **********************/
/*******************         Image windows        **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'hrct' (rImageWindow, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rImageWindow + generalHelpOffset, 1
		}
	}
};

resource 'STR#' (rImageWindow + generalHelpOffset, purgeable)
{
	{
		"This is a JPEGView image window.\n\n"
			"Hint: To change the size of the image, move "
			"to the bottom-right corner of the window, then click and drag when the "
			"cursor changes.  Hold down the shift key for full resizing freedom."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************      Help Window     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hrct' (rHelpWindow, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rHelpWindow + generalHelpOffset, 1
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rHelpWindow + generalHelpOffset, 2
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rHelpWindow + generalHelpOffset, 3
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rHelpWindow + generalHelpOffset, 4
		}
	}
};

resource 'STR#' (rHelpWindow + generalHelpOffset, purgeable)
{
	{
		"Size box\n\n"
			"To change the height and width of the window, drag the size box.",
		"Scroll bar\n\n"
			"To scroll a little at a time, press one of the scroll arrows.  "
			"To scroll by the windowful, click in the gray bar.  "
			"To scroll to another part of the window, drag the scroll box.",
		"Use this pop-up menu to select a different help topic to display.",
		"This is the help information you requested.  Use the scroll bar to the "
			"right to view the rest of the text.  Use the pop-up menu above to "
			"choose a new topic."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************Slide Controls Window *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hrct' (rSlideControlsWindow, purgeable)
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 1
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 2
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 3
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 4
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 5
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 6
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 7
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 8
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 9
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 10
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			0, 0
		},
		HMStringResItem {
			{ 0, 0 },
			{ 0, 0, 0, 0 },
			rSlideControlsWindow + generalHelpOffset, 11
		}
	}
};

resource 'STR#' (rSlideControlsWindow + generalHelpOffset, purgeable)
{
	{
		"This status line describes what JPEGView is currently busy doing "
			"in order to prepare the next slide for display.",
		"Reverse button\n\n"
			"To manually return to the previous slide, click here.  Note that there may "
			"be a delay as the slide is loaded and prepared for viewing.",
		"Stop button\n\n"
			"To end the slide show, click here.",
		"Pause button\n\n"
			"To pause the slide show and display the menu bar, click here.  Hold "
			"down the option key and click here to hide the slide show.",
		"Forward button\n\n"
			"To manually advance to the next slide, click here.  Note that there may "
			"be a delay as the slide is loaded and prepared for viewing.",
		"Reverse button\n\n"
			"Manually returns to the previous slide.  Depressed because "
			"JPEGView is waiting to process your request.",
		"Stop button\n\n"
			"Ends the slide show.  Depressed because JPEGView is waiting "
			"to process your request.",
		"Pause button\n\n"
			"The slide show is currently paused.  To resume the slide show "
			"where you left off, click here.",
		"Forward button\n\n"
			"Manually advances to the next slide.  Depressed because "
			"JPEGView is waiting to process your request.",
		"Reverse button\n\n"
			"Manually returns to the previous slide.  Not "
			"available because JPEGView cannot back up from the current "
			"slide.",
		"Forward button\n\n"
			"Manually advances to the next slide.  Not "
			"available because JPEGView cannot advance from the current "
			"slide."
	}
};
