/*********************************************************/
/* This source code copyright (c) 1991-2001, Aaron Giles */
/* See the Read Me file for licensing information.       */
/* Contact email: mac@aarongiles.com                     */
/*********************************************************/

/*
 * JPEGView resource definition file
 *
 */

//====================================================
// NOTE: We needed to change two things for 3.2.1:
// Explicit +1 in vers resources, and a ".1" in the
// version strings in the STR# resources
//====================================================

#define SystemSevenOrLater 1

#include "SysTypes.r"
#include "Types.r"
#include "BalloonTypes.r"
#include "JPEGView.r.h"

#define generalHelpOffset 3000

/***********************************************************************/
/************************                      *************************/
/************************   Version Resource   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'vers' (1) 
{
	(kVersion >> 8), (kVersion & 0xff), final, 0,
	verUS,
	"3.3fc1",
	"3.3fc1  199294, Aaron Giles\n"
	"All Rights Reserved"
};

resource 'vers' (2) 
{
	(kVersion >> 8), (kVersion & 0xff), final, 0,
	verUS,
	"3.3fc1",
#ifdef PPC
	"for PowerPC Macintoshes"
#else
#ifdef FAT
	"for 680x0 and PowerPC Macintoshes"
#else
	"for 680x0 Macintoshes"
#endif
#endif
};

/***********************************************************************/
/************************                      *************************/
/************************     Size Resource    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'SIZE' (0)
{
	reserved, 
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	useTextEditServices,
	reserved,
	reserved,
	reserved,
	
	1100 * 1024,
	800 * 1024
};

resource 'SIZE' (-1)
{
	reserved, 
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	getFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	useTextEditServices,
	reserved,
	reserved,
	reserved,
	
	800 * 1024,
	800 * 1024
};

/***********************************************************************/
/************************                      *************************/
/************************  FREF / BNDL / JVWR  *************************/
/************************                      *************************/
/***********************************************************************/

resource 'FREF' (rAPPLType) 
{
	kAPPLType, rAPPLID, ""
};

resource 'FREF' (rPICTType) 
{
	kPICTType, rPICTID, ""
};

resource 'FREF' (rJFIFType) 
{
	kJFIFType, rJFIFID, ""
};

resource 'FREF' (rJPEGType) 
{
	kJPEGType, rJPEGID, ""
};

resource 'FREF' (rHelpType) 
{
	kHelpType, rHelpID, ""
};

resource 'FREF' (rGIFType) 
{
	kGIFType, rGIFID, ""
};

resource 'FREF' (rAllTypes) 
{
	kAllTypes, rAllID, ""
};

resource 'FREF' (rTIFFType) 
{
	kTIFFType, rTIFFID, ""
};

resource 'FREF' (rBMPType) 
{
	kBMPType, rBMPID, ""
};

resource 'FREF' (rSCRNType) 
{
	kSCRNType, rSCRNID, ""
};

resource 'FREF' (rPNTGType) 
{
	kPNTGType, rPNTGID, ""
};

resource 'BNDL' (rBNDLRsrc) 
{
	kCreator, rJVWRRsrc,
	{
		'FREF',
		{
			rAPPLID, rAPPLType,
			rPICTID, rPICTType,
			rJFIFID, rJFIFType,
			rJPEGID, rJPEGType,
			rHelpID, rHelpType,
			rGIFID, rGIFType,
			rAllID, rAllTypes,
			rTIFFID, rTIFFType,
			rBMPID, rBMPType,
			rSCRNID, rSCRNType,
			rPNTGID, rPNTGType
		},
		'ICN#',
		{
			rAPPLID, rAPPLIcon,
			rPICTID, rPICTIcon,
			rJFIFID, rJPEGIcon,
			rJPEGID, rJPEGIcon,
			rHelpID, rHelpIcon,
			rGIFID, rGIFIcon,
			rAllID, rOtherIcon,
			rTIFFID, rTIFFIcon,
			rBMPID, rBMPIcon,
			rSCRNID, rSCRNIcon,
			rPNTGID, rPNTGIcon
		}
	}
};

type kCreator as 'STR ';
resource kCreator (rJVWRRsrc) 
{
	"JPEGView Version 3.2"
};

/***********************************************************************/
/************************                      *************************/
/************************     Finder Help      *************************/
/************************                      *************************/
/***********************************************************************/

resource 'hfdr' (-5696, purgeable) 
{
	HelpMgrVersion, hmDefaultOptions, 0, 0,
	{
		HMStringItem {
			"JPEGView is a nifty utility that can quickly view JPEG, GIF, TIFF, "
				"PICT, MacPaint, and Startup Screen files.  It even comes with "
				"a slide show and extensive on-line help!"
		}
	}
};

/***********************************************************************/
/*******************                              **********************/
/*******************       Statistics Window      **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'WIND' (rStatWindow, preload)
{
	{ 0, 0, 100, 100 },
	windoidZoomProc, invisible, goAway, kStatWindowID, "Statistics",
	noAutoCenter
};

/***********************************************************************/
/*******************                              **********************/
/*******************        Comments window       **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'WIND' (rCommentsWindow, preload)
{
	{ 0, 0, 100, 100 },
	windoidProc, invisible, goAway, kCommentsWindowID, "Comments",
	noAutoCenter
};

/***********************************************************************/
/*******************                              **********************/
/*******************         Colors window        **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'WIND' (rColorsWindow, preload)
{
	{ 0, 0, 49, 257 },
	windoidProc, invisible, goAway, kColorsWindowID, "Colors",
	noAutoCenter
};

resource 'wctb' (rColorsWindow, preload) 
{
	{ }, { }
};

/***********************************************************************/
/*******************                              **********************/
/*******************         Image windows        **********************/
/*******************                              **********************/
/***********************************************************************/

resource 'WIND' (rImageWindow, preload)
{
	{ 0, 0, 100, 100 },
	zoomNoGrow, invisible, goAway, kImageWindowID, "",
	noAutoCenter
};

resource 'wctb' (rImageWindow, preload) 
{
	{
		wContentColor, 0x0000, 0x0000, 0x0000,
		wFrameColor, 0x1111, 0x1111, 0x1111
	}, { }
};

resource 'WIND' (rFullImageWindow, preload)
{
	{ 0, 0, 100, 100 },
	plainDBox, invisible, goAway, kImageWindowID, "",
	noAutoCenter
};

resource 'wctb' (rFullImageWindow, preload) 
{
	{
		wContentColor, 0x0000, 0x0000, 0x0000,
		wFrameColor, 0x1111, 0x1111, 0x1111
	}, { }
};

resource 'WIND' (rAboutImageWindow, preload)
{
	{ 0, 0, 100, 100 },
	noGrowDocProc, invisible, goAway, kImageWindowID, "",
	noAutoCenter
};

resource 'wctb' (rAboutImageWindow, preload) 
{
	{
		wContentColor, 0x0000, 0x0000, 0x0000,
		wFrameColor, 0x1111, 0x1111, 0x1111
	}, { }
};

/***********************************************************************/
/************************                      *************************/
/************************      Help Window     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'WIND' (rHelpWindow, preload) 
{
	{ 0, 0, 300, 480 },
	zoomDocProc, invisible, goAway, kHelpWindowID, "JPEGView Help",
	noAutoCenter
};

resource 'CNTL' (rHelpMenuControl, preload) 
{
	{ 7, 0, 26, 375 },
	popupTitleLeftJust, visible, 80, rHelpMenu, popupMenuCDEFProc, 0, "Help Topic:"
};

resource 'CNTL' (rHelpScrollControl, preload) 
{
	{ 22, 460, 279, 476 },
	0, visible, 0, 0, scrollBarProc, 0, ""
};

/***********************************************************************/
/************************                      *************************/
/************************Slide Controls Window *************************/
/************************                      *************************/
/***********************************************************************/

resource 'WIND' (rSlideControlsWindow, preload) 
{
	{ 0, 0, 29, 28 * 4 },
	windoidProc, invisible, noGoAway, kSlideControlsWindowID, "Slide Show",
	noAutoCenter
};

resource 'wctb' (rSlideControlsWindow, preload) 
{
	{ }, { }
};

/***********************************************************************/
/************************                      *************************/
/************************    Error Messages    *************************/
/************************                      *************************/
/***********************************************************************/

resource 'STR#' (rFatalErrors, preload) 
{
	{
		"Not enough memory to start up!",
		"Couldnt load all the code resources!",
		"Couldnt load the string resources!",
		"Couldnt load the cursors!",
		"JPEGView requires System 7.0 or later to run!",
		"Couldnt find the system color tables!",
		"Couldnt load the application menus!",
		"Couldnt install the supported AppleEvents!",
		"Unable to identify the active screen devices!"
	}
};

resource 'STR#' (rMinorErrors, preload)
{
	{
		"Not enough memory to complete this operation.",
		"Your version of QuickTime has a strange version number; proceed with caution.",
		"Couldnt load the About dialog.",
		"Couldnt send the appropriate AppleEvent.",
		"Couldnt set up the Help window.",
		"Couldnt load the Preferences dialog.",
		"Couldnt write the Preferences file.",
		"No valid image files found.",
		"Couldnt load the Slide Show dialog.",
		"Couldnt create the preview image.",
		"No printer is selected.  Please open the Chooser and select a printer.",
		"JPEGViews help file JPEGView Help could not be found in the JPEGView folder." 
	}
};

resource 'STR#' (rStringErrors, preload)
{
	{
		"The image data for ^1 is corrupt.",
		"^1 is not a valid image file.",
		"Unable to open the input file ^1.",
		"Not enough memory to draw the image ^1.",
		"Not enough memory to load the file ^1.",
		"Unable to read the file ^1.",
		"Unable to write the file ^1.",
		"Unable to create the file ^1.",
		"Not enough memory to convert ^1 into a PICT.",
		"Not enough memory to convert ^1 into JFIF format.",
		"Unable to open a window for ^1.",
		"Not enough memory to create an offscreen bitmap for ^1.",
		"Not enough memory to reduce ^1.",
		"Unable to create a preview image for ^1.",
		"Not enough memory to save the color reduction in ^1.",
		"Unable to create custom icons for ^1.",
		"Not enough memory to crop ^1.",
		"Not enough memory to save ^1.",
		"^1 is an HSI JPEG file, in a proprietary format that JPEGView cannot read.",
		"Not enough memory to print the file ^1.",
		"Unable to print the image ^1.",
		"Not enough memory to copy the image ^1.",
		"^1 is not a Baseline or LZW-compressed TIFF image.",
		"The image ^1 could not be displayed because QuickTime is not installed.",
		"Corrupt JPEG data found (^1).",
		"The file ^1 contains BinHex-encoded data, which must be decoded before opening.",
		"The file ^1 contains uuencoded data, which must be decoded before opening."
	}
};

resource 'STR#' (rGenericStringErrors, preload)
{
	{
		"The image data is corrupt.",
		"This is not a valid image file.",
		"Unable to open the input file.",
		"Not enough memory to draw the image.",
		"Not enough memory to load the file.",
		"Unable to read the file.",
		"Unable to write the file.",
		"Unable to create the file.",
		"Not enough memory to convert the image into a PICT.",
		"Not enough memory to convert the image into JFIF format.",
		"Unable to open a window for this image.",
		"Not enough memory to create an offscreen bitmap for this image.",
		"Not enough memory to reduce this image.",
		"Unable to create a preview.",
		"Not enough memory to save the color reduction with this image.",
		"Unable to create custom icons for this image.",
		"Not enough memory to crop this image.",
		"Not enough memory to save this image.",
		"This image is an HSI JPEG file, in a proprietary format that JPEGView cannot read.",
		"Not enough memory to print this image.",
		"Unable to print this image.",
		"Not enough memory to copy this image.",
		"This image is not a Baseline or LZW-compressed TIFF.",
		"This image could not be displayed because QuickTime is not installed.",
		"Corrupt JPEG data found (^1).",
		"This file contains BinHex-encoded data, which must be decoded before opening.",
		"This file contains uuencoded data, which must be decoded before opening."
	}
};

/***********************************************************************/
/************************                      *************************/
/************************    General Strings   *************************/
/************************                      *************************/
/***********************************************************************/

resource 'STR#' (rStrings, preload) 
{
	{
		"File Name: ",
		"Image Size: ",
		"Image Colors: ",
		"Image Status: ",
		"Compression: ",
		"File Format: ",
		"Image Length: ",

		"Displayed Size: ",
		"Displayed Colors: ",
		"Display Quality: ",
		"Display Time: ",
		"Offscreen Bitmap: ",

		"Free Memory: ",

		"~1 x ~2",								// Image size
		"~1 x ~2 (originally ~3 x ~4)",
		"~1",									// Image colors
		"~1 grayscales",
		"Normal",								// Image status
		"Aborted",
		"Banded",
		"Cropped",
		"Corrupt",
		"LZW/GIF",								// Image compression
		"JPEG (Adobe)",
		"JPEG (QuickTime)",
		" (quality: ~1.~2)",
		"JPEG (est. IJG quality: ~1)",
		"JPEG",
		"Uncompressed",
		"PICT",									// File format
		"JFIF",
		"GIF",
		"~1K",									// Image length
		"~1K, or ~2% compression",
		"~1K, or ~2:1 compression",

		"~1 x ~2",								// Displayed size
		"~1 x ~2 (scaled by ~3%)",
		"~1 x ~2 (scaled by ~3%/~4%)",
		"~1",									// Displayed colors
		"~1, without dithering",
		"~1 system colors",
		"~1 grayscales",
		"~1 image colors",
		"~1 reduced colors",
		"~1 system colors, without dithering",
		"~1 grayscales, without dithering",
		"~1 image colors, without dithering",
		"~1 reduced colors, without dithering",
		"Very high",							// Display quality
		"High",
		"Normal",
		"n/a",
		"~1.~2 seconds",						// Display time
		"No bitmap",							// Offscreen bitmap
		"~1K",
		"~1K, at images original size",
		"~1K",									// Free memory
		
		"~1: ~2K ~3, ~4 x ~5 x ~6",				// Summary lines
		
		"Thousands",
		"Millions",
		"JPEGView",
		"JPEGView Help",
		"JPEGView PICT",
		"JPEGView Preferences",
		"JVTmpFil",
		"Select",
		"Desktop",
		"Decompressing ~1%",
		"Dithering ~1%",
		"Scaling ~1%",
		"Reducing to ^1 colors",
		"Creating preview image",
		"Creating custom icons",
		"Creating preview and icons",
		"Saving",
		
		" ",
		"Just a reminder...",
		" ",
		"JPEGView is postcardware",
		"Have you sent in your postcard yet?",
		" ",
		"It only takes a couple minutes!",
		"Aaron Giles",
		"182 E. 95th Street 11E",
		"New York, NY 10128  U.S.A.",
		" ",
		"I look forward to hearing from you!",
		
		"No comments found",
		"Restart",
		"Resume",
		"Show Statistics",
		"Hide Statistics",
		"Show Comments",
		"Hide Comments",
		"Show Colors",
		"Hide Colors",
		"Begin Slide Show",
		"Resume Slide Show",
		"<None>",
		"About JPEGView",
		"version ~1.~2, running native on a PowerPC",
		"version ~1.~2",

		"Loading: ~1",
		"Reducing: ~1",
		"Drawing: ~1",
		"Ready",
		"Paused",
		"Delaying... ~1",
		"Rendering: ~1",
		"Scanning folder",
		"Printing",
		"Copying",
		"Preparing",
		"Modified CCITT RLE",
		"PackBits",
		"LZW",
		"4-bit RLE",
		"8-bit RLE",
		"LZW with prediction",
		"JPEGView Help"
	}
};

resource 'STR#' (rFormatNames, preload) 
{
	{
		"PICT",
		"JFIF",
		"GIF",
		"TIFF",
		"BMP",
		"Startup Screen",
		"MacPaint",
		"PICT Resource"
	}
};
