/*********************************************************/
/* This source code copyright (c) 1991-2001, Aaron Giles */
/* See the Read Me file for licensing information.       */
/* Contact email: mac@aarongiles.com                     */
/*********************************************************/

#define SystemSevenOrLater 1

#include "SysTypes.r"
#include "Types.r"
#include "BalloonTypes.r"
#include "JPEGView.r.h"

#define menuHelpOffset 2000

/***********************************************************************/
/************************                      *************************/
/************************     The Menu Bar     *************************/
/************************                      *************************/
/***********************************************************************/

resource 'MBAR' (rMenuBar, preload) 
{
  	{
  		rAppleMenu,
		rFileMenu,
		rEditMenu,
		rViewMenu,
		rColorsMenu,
		rWindowMenu 
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************     Icon Pop-Up Menu      **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rIconMenu, preload) 
{
	rIconMenu, textMenuProc, 
	allEnabled,
	enabled, "",
	{
		"Square", 1, noKey, noMark, plain,
		"Square, dog-eared", 2, noKey, noMark, plain,
		"Proportional", 3, noKey, noMark, plain,
		"Proportional, dog-eared", 4, noKey, noMark, plain
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************     Crop Pop-Up Menu      **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rCropMenu, preload) 
{
	rCropMenu, textMenuProc, 
	allEnabled,
	enabled, "",
	{
		"Nothing", noIcon, noKey, noMark, plain,
		"Icon", noIcon, noKey, noMark, plain,
		"Image", noIcon, noKey, noMark, plain
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************    Save As Pop-Up Menu    **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rSaveMenu, preload) 
{
	rSaveMenu, textMenuProc, 
	allEnabled,
	enabled, "",
	{
	}
};

/***********************************************************************/
/**********************                           **********************/
/********************** Slide Control Pop-Up Menu **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rSlideControlMenu, preload) 
{
	rSlideControlMenu, textMenuProc, 
	allEnabled,
	enabled, "",
	{
		"User-controlled", noIcon, noKey, noMark, plain,
		"Automatic", noIcon, noKey, noMark, plain
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************  Slide Source Pop-Up Menu **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rSlideSourceMenu, preload) 
{
	rSlideSourceMenu, textMenuProc, 
	allEnabled,
	enabled, "",
	{
		"Images in Memory", noIcon, noKey, noMark, plain,
		"Images from Disk", noIcon, noKey, noMark, plain
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************      Time Pop-Up Menu     **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rTimeMenu, preload) 
{
	rTimeMenu, textMenuProc, 
	allEnabled,
	enabled, "",
	{
		"seconds", noIcon, noKey, noMark, plain,
		"minutes", noIcon, noKey, noMark, plain,
		"hours", noIcon, noKey, noMark, plain,
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************    Quality Menu    **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rQualityMenu, preload) 
{
	rQualityMenu, customMenuProc,
	allEnabled,
	enabled, "",
	{
		"Very High", noIcon, "V", noMark, shift,
		"High", noIcon, "H", noMark, shift,
		"Normal", noIcon, "N", noMark, shift,
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************     Prefs Pop-Up Menu     **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rPrefsMenu, preload) 
{
	rPrefsMenu, textMenuProc, 
	allEnabled,
	enabled, "Preferences",
	{
		"Windows", noIcon, noKey, noMark, plain,
		"Display", noIcon, noKey, noMark, plain,
		"Bitmaps", noIcon, noKey, noMark, plain,
		"Files", noIcon, noKey, noMark, plain,
		"Miscellany", noIcon, noKey, noMark, plain,
	}
};

/***********************************************************************/
/**********************                           **********************/
/**********************      Help Pop-Up Menu     **********************/
/**********************                           **********************/
/***********************************************************************/

resource 'MENU' (rHelpMenu, preload) 
{
	rHelpMenu, textMenuProc,
	allEnabled,
	enabled, "",
	{
		"Introduction", noIcon, noKey, noMark, plain,
		"Viewing Images", noIcon, noKey, noMark, plain,
		"The How and Why of Floating Windows", noIcon, noKey, noMark, plain,
		"Special Effects", noIcon, noKey, noMark, plain,
		"Colors And Color Reduction", noIcon, noKey, noMark, plain,
		"Saving Images", noIcon, noKey, noMark, plain,
		"Slide Show", noIcon, noKey, noMark, plain,
		"Preferences Settings", noIcon, noKey, noMark, plain,
		"File Formats and File Types", noIcon, noKey, noMark, plain,
		"Scripting JPEGView", noIcon, noKey, noMark, plain,
		"General JPEG Questions & Answers", noIcon, noKey, noMark, plain,
		"JPEGView Questions & Answers", noIcon, noKey, noMark, plain,
		"Hints And Tips", noIcon, noKey, noMark, plain,
		"Contacting the Author", noIcon, noKey, noMark, plain,
		"Acknowledgments", noIcon, noKey, noMark, plain,
		"Program History", noIcon, noKey, noMark, plain
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************     Apple Menu     **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rAppleMenu, preload) 
{
	rAppleMenu,	customMenuProc,
	0b1111111111111111111111111111011,
	enabled, apple,
	{
		"About JPEGView", noIcon, noKey, noMark, plain,
		"About JPEGView Help", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************      File Menu     **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rFileMenu, preload) 
{
	rFileMenu, customMenuProc,
	0b1111111111111111110010010000011,
	enabled, "File",
	{
		"Open...", noIcon, "O", noMark, plain,
		"Import...", noIcon, "O", noMark, shift,
		"Close", noIcon, "W", noMark, plain,
		"Close All Images", noIcon, "W", noMark, shift,
		"-", noIcon, noKey, noMark, plain,
		"Save As...", noIcon, "S", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Slide Show Options", noIcon, "I", noMark, plain,
		"Begin Slide Show", noIcon, "I", noMark, shift,
		"End Slide Show", noIcon, ".", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Page Setup...", noIcon, noKey, noMark, plain,
		"Print...", noIcon, "P", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Preferences", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Quit", noIcon, "Q", noMark, plain
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************      Edit Menu     **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rEditMenu, preload) 
{
	rEditMenu, customMenuProc,
	0b1111111111111111111100000000000,
	disabled, "Edit",
	{
		"Undo", noIcon, "Z", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Cut", noIcon, "X", noMark, plain,
		"Copy", noIcon, "C", noMark, plain,
		"Paste", noIcon, "V", noMark, plain,
		"Clear", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Select Screen Area", noIcon, "A", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Crop & Zoom", noIcon, "R", noMark, plain,
		"Uncrop", noIcon, "U", noMark, plain,
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************      View Menu     **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rViewMenu, preload) 
{
	rViewMenu, customMenuProc,
	0b1111111111111111111111011110101,
	disabled, "View",
	{
		"Full Screen", noIcon, "F", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Resize To Screen", noIcon, "E", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Normal Size", noIcon, "L", noMark, plain,
		"Halve Size", noIcon, "H", noMark, plain,
		"Double Size", noIcon, "D", noMark, plain,
		"Maximum Size", noIcon, "M", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Shrink By 10%", noIcon, "[", noMark, plain,
		"Expand By 10%", noIcon, "]", noMark, plain
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************    Colors Menu     **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rColorsMenu, preload) 
{
	rColorsMenu, customMenuProc,
	0b1111111111111111111111110101111,
	disabled, "Colors",
	{
		"System Colors", noIcon, "Y", noMark, plain,
		"Grayscales", noIcon, "G", noMark, plain,
		"Image Colors", noIcon, "J", noMark, plain,
		"Two-Pass Color Reduction", noIcon, "T", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Dithering", noIcon, "B", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Quality", noIcon, hierarchicalMenu, rQualityMenuID, plain
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************     Window Menu    **************************/
/*************************                    **************************/
/***********************************************************************/

resource 'MENU' (rWindowMenu, preload) 
{
	rWindowMenu, customMenuProc,
	0b1111111111111111111111110000111,
	enabled, "Window",
	{
		"Show Statistics", noIcon, "0", noMark, plain,
		"Show Comments", noIcon, "`", noMark, plain,
		"Show Colors", noIcon, "\\", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Previous Image", noIcon, "-", noMark, plain,
		"Next Image", noIcon, "+", noMark, plain
	}
};

/***********************************************************************/
/*************************                    **************************/
/*************************      Help Menu     **************************/
/*************************                    **************************/
/***********************************************************************/

